if UVSPF == nil then UVSPF = {} end
UVSPF.AddonName = "UVSPF"
UVSPF.version = 1.0
UVSPF.active = false
UVSPF.cache = {}
UVSPF.GUI = {}
local selectedChar = GetCurrentCharacterId()
local currentCharName = nil
local debugMode = false
local EM = EVENT_MANAGER
local GZNBId, GCCId, GCQI = GetZoneNameById, GetCurrentCharacterId, GetCompletedQuestInfo
local IAchC, GAchNCr, GAchCr = IsAchievementComplete, GetAchievementNumCriteria, GetAchievementCriterion
local GS, zf, strF = GetString, zo_strformat, string.format
local _

local UVSPF_LTF = LibTableFunctions
if (not UVSPF_LTF) then return end

UVSPF.settings = {  --UI Settings
	title = {font = "ProseAntique",},
	GSP = {
		font = "Univers 57",
		doneColor = {1, 1, 1},
		needColor = {1, 0, 0},
		progColor = {1, 0.1, 0.7},
	},
	SQS = {  --Questlines & Soulshards?
		font = "Univers 57",
		doneColorSS = {1, 1, 1},
		doneColorZQ = {1, 1, 1},
		needColorSS = {1, 0, 0},
		needColorZQ = {1, 0, 0},
		progColorSS = {0.7843, 0.3922, 0},
		progColorZQ = {0.7843, 0.3922, 0},
		sortCol = 1,
	},
	GDQ = {  --Group Dungeons
		font = "Univers 57",
		doneColor = {1, 1, 1},
		needColor = {1, 0, 0},
		sortCol = 1,
	},
	PDB = {  --Public Dungeons
		font = "Univers 57",
		doneColor = {1, 1, 1},
		needColor = {1, 0, 0},
		sortCol = 1,
	},
	FD = {
		override = false,
		charHasFD = false,
	},
	MWC = false,
	SSC = false,
	EWC = false,
  	GMC = false,
  	BWC = false,
}

UVSPF.defaults = {
	firstRun = true,
	numChars = 0,
	charInfo = {},
	settings = {},
	ptsData = {},
}


UVSPF.ptsData = {  --All Data sources - initial values
	Tot		= 0, GenTot	 = 0, ZQTot	  = 0, numSSTot	= 0, SSTot	= 0,
	GDTot	= 0, PDTot	 = 0, Level	  = 0, MainQ	= 0, FolDis	= 0,
	MWChar	= 0, SUChar  = 0, EWChar  = 0, GMChar   = 0, BWChar = 0,
  	PvPRank	= 0, MaelAr	= 0, VatAr = 0,
	ZQ = {	--Zone Quests
		AD0 = 0, AD1 = 0, AD2 = 0, AD3 = 0, AD4 = 0, AD5  = 0, DC0a = 0, DC0b = 0,
		DC1 = 0, DC2 = 0, DC3 = 0, DC4 = 0, DC5 = 0, EP0a = 0, EP0b = 0, EP1  = 0,
		EP2 = 0, EP3 = 0, EP4 = 0, EP5 = 0, CH  = 0, CAD  = 0, CDC  = 0, CEP  = 0,
		CMT = 0, LCL = 0, UCL = 0, CC  = 0, DB  = 0, IC   = 0, MW   = 0, RO   = 0,
		TG  = 0, SU  = 0, MM  = 0, NE  = 0, WP  = 0, SE   = 0, WS =   0, TR   = 0,
		BW  = 0,
	},
	SS = {	--Soulshards
		AD0 = 0, AD1 = 0, AD2 = 0, AD3 = 0, AD4 = 0, AD5  = 0, DC0a = 0, DC0b = 0,
		DC1 = 0, DC2 = 0, DC3 = 0, DC4 = 0, DC5 = 0, EP0a = 0, EP0b = 0, EP1  = 0,
		EP2 = 0, EP3 = 0, EP4 = 0, EP5 = 0, CH  = 0, CAD  = 0, CDC  = 0, CEP  = 0,
		CMT = 0, LCL = 0, UCL = 0, IC  = 0, WR  = 0, HB   = 0, GC   = 0, VV   = 0,
		CC  = 0, MQ  = 0, SU  = 0, MM  = 0, NE  = 0, SE   = 0, WS	= 0, TR   = 0,
		BW  = 0,
	},
	GD = {	--Group Dungeons
		BC1 = 0, BC2 = 0, EH1 = 0, EH2 = 0, CA1 = 0, CA2 = 0, TI = 0, SW = 0,
		SC1 = 0, SC2 = 0, WS1 = 0, WS2 = 0, CH1 = 0, CH2 = 0, VF = 0, BH = 0,
		FG1 = 0, FG2 = 0, DC1 = 0, DC2 = 0, AC  = 0, DK  = 0, BC = 0, VM = 0,
		WGT = 0, ICP = 0, RM  = 0, CS  = 0, BF  = 0, FH  = 0, FL = 0, SP = 0,
		MHK = 0, MOS = 0, DoM = 0, FV  = 0, LM  = 0, MF  = 0, IR = 0, UG = 0,
		SG  = 0, CT  = 0, CD  = 0, BDV = 0, 
	},
	PD = {	--Public Dungeons
		AD1 = 0, AD2 = 0, AD3 = 0, AD4 = 0, AD5 = 0, DC1 = 0, DC2 = 0, DC3 = 0,
		DC4 = 0, DC5 = 0, EP1 = 0, EP2 = 0, EP3 = 0, EP4 = 0, EP5 = 0, CH  = 0,
		VFW = 0, VNC = 0, WOO = 0, WRK = 0, SKW = 0, SSH = 0, RN  = 0, OC  = 0,
    	LT  = 0, NK  = 0, ZA  = 0, TSH = 0,
	},
}

UVSPF.ptsTots = {	--Tot and GenTot are 444 and 130 because you can't do more than one DLC tutorial.
	Tot		= 477, GenTot = 128, ZQTot	= 112, numSSTot	= 495, SSTot  = 165,
	GDTot	=  44, PDTot  =  28, Level	=  64, MainQ	=  11, FolDis =   2,
	MWChar	=   1, SUChar =   1, EWChar =   1, GMChar   =  1,  BWChar =   1,
    PvPRank  =  50, MaelAr =   1, VatAr = 1,
	ZQ = {
		AD0 = 0, AD1 = 3, AD2 =  3, AD3 = 3, AD4 = 3, AD5  = 3, DC0a = 0, DC0b = 0,
		DC1 = 4, DC2 = 3, DC3 =  3, DC4 = 3, DC5 = 3, EP0a = 0, EP0b = 0, EP1  = 3,
		EP2 = 3, EP3 = 3, EP4 =  3, EP5 = 3, CH  = 3, CAD  = 0, CDC  = 0, CEP  = 0,
		CMT = 0, LCL = 0, UCL =  0, CC  = 8, DB  = 8, IC   = 1, MW   = 3, RO   = 3,
		TG  = 6, SU  = 3, MM  =  7, NE  = 3, WP  = 0, SE   = 9, WS   = 3, TR   = 6,
		BW  = 3,
	},
	SS = {
		AD0  = 6,  AD1 = 16, AD2 = 16, AD3 = 16, AD4 = 16, AD5 = 16, DC0a = 3,
		DC0b = 3,  DC1 = 16, DC2 = 16, DC3 = 16, DC4 = 16, DC5 = 16, EP0a = 3,
		EP0b = 3,  EP1 = 16, EP2 = 16, EP3 = 16, EP4 = 16, EP5 = 16, CH   = 16,
		CAD  = 15, CDC = 15, CEP = 15, CMT = 1,  LCL = 12, UCL = 6,  IC   = 13,
		WR   = 17, HB  = 6,  GC  = 6,  VV  = 18, CC  = 6,  MQ  = 1,  SU   = 18,
		MM   = 6,  NE  = 18, SE  = 6,  WS  = 18, TR  = 6,  BW  = 18
	},
	GD = {
		BC1 = 1, BC2 = 1, EH1 = 1, EH2 = 1, CA1 = 1, CA2 = 1, TI = 1, SW = 1,
		SC1 = 1, SC2 = 1, WS1 = 1, WS2 = 1, CH1 = 1, CH2 = 1, VF = 1, BH = 1,
		FG1 = 1, FG2 = 1, DC1 = 1, DC2 = 1, AC  = 1, DK  = 1, BC = 1, VM = 1,
		WGT = 1, ICP = 1, RM  = 1, CS  = 1, BF  = 1, FH  = 1, FL = 1, SP = 1,
		MHK = 1, MOS = 1, DoM = 1, FV  = 1, LM  = 1, MF  = 1, IR = 1, UG = 1,
		SG  = 1, CT  = 1, CD  = 1, BDV = 1,
	},
	PD = {
		AD1 = 1, AD2 = 1, AD3 = 1, AD4 = 1, AD5 = 1, DC1 = 1, DC2 = 1, DC3 = 1,
		DC4 = 1, DC5 = 1, EP1 = 1, EP2 = 1, EP3 = 1, EP4 = 1, EP5 = 1, CH  = 1,
		VFW = 1, VNC = 1, WOO = 1, WRK = 1, SKW = 1, SSH = 1, RN  = 1, OC  = 1,
    	LT  = 1, NK  = 1, ZA  = 1, TSH = 1,
	},
}

local tempZId = {  --Zone IDs: updated info on https://api.eso-database.com/v2/api/get-game-data-zones
	ZN = {  --Main Zones
		AD0  = 537, AD1  =  381, AD2  = 383, AD3 =  108, AD4 =  58, AD5 =  382, 
		DC0A = 535, DC0B =  534, DC1  =   3, DC2 =   19, DC3 =  20, DC4 =  104,
		DC5  =  92, EP0B =  280, EP0A = 281, EP1 =   41, EP2 =  57, EP3 =  117,
		EP4  = 101, EP5  =  103, CH   = 347, CYD =  181, CAD = 181, CDC =  181,
		CEP  = 181, CMT  =  181, CL   = 888, LCL =  888, UCL = 888, IC  =  584,
		RO   = 684, HB   =  816, GC   = 823, VV  =  849, CC  = 980, SU  = 1011,
		MM   = 726, NE   = 1086, WP   = 586, SE  = 1133, WS = 1160, BGC = 1161,
		TR   = 1207,BW   = 1261,
	},
	GDN = {  --Group Dungeons
		BC1 =  380, BC2 =  935, EH1 =  126, EH2 =  931, CA1 =  176, CA2 =  681,
		TI  =  131, SW  =   31, SC1 =  144, SC2 =  936, WS1 =  146, WS2 =  933,
		CH1 =  130, CH2 =  932, VF  =   22, BH  =   38, FG1 =  283, FG2 =  934,
		DC1 =   63, DC2 =  930, AC  =  148, DK  =  449, BC  =   64, VM  =   11,
		ICP =  678, WGT =  688, CS  =  848, RM  =  843, BF  =  973, FH  =  974,
		FL  = 1009, SP	= 1010, MHK = 1052, MOS = 1055, DoM = 1081, FV  = 1080,
		LM  = 1123, MF  = 1122, IR  = 1152, UG  = 1153, SG  = 1197, CT  = 1201,
		CD  = 1229, BDV = 1228,
	},
	PDN = {  --Public Dungeons: updated info on https://api.eso-database.com/v2/api/get-game-data-zones
		AD1 = 486, AD2 = 124, AD3 =  137, AD4 =  138, AD5 =  487, DC1 =  284,
		DC2 = 142, DC3 = 162, DC4 =  308, DC5 =  169, EP1 =  216, EP2 =  306,
		EP3 = 134, EP4 = 339, EP5 =  341, CH  =  557, WOO =  706, WRK =  705,
		VFW = 919, VNC = 918, SKW = 1020, SSH = 1021, RN  = 1089, OC  = 1090,
    	LT = 1186, NK = 1187, ZA  = 1259, TSH = 1260,
	},
}

UVSPF.data = {  --Data containing Quests/Quest IDs to trace the completion skillpoints
	ZId = tempZId,
	MAAch = 1304,
	VAAch = 2907,
	MQAch = 1003,
	ZQAch = {  --Zones Quest Acheivements
		AD1 =  943, AD2 =  944, AD3 =  945, AD4 =  946, AD5 =  947, CC  = 2064,
		CH  =  957, DB  = 1444, DC1 =  953, DC2 =  954, DC3 =  955, DC4 =  956,
		DC5 =  958, EP1 =  948, EP2 =  949, EP3 =  950, EP4 =  951, EP5 =  952,
		IC  = 1175, RO  = 1260, TG  = 1363, SU  = 2208, MM  = 2339, NE  = 2488,
		SE  = 2604, WS  = 2722, TR  = 2957, BW  = 3056,
	},
	AD1 = {	--943
		{4222,  360, zf("<<t:1>>", GS(UVSPF_QUEST_AD1_1)),	1},
		{4345,  361, zf("<<t:1>>", GS(UVSPF_QUEST_AD1_2)),	1},
		{4261,  362, zf("<<t:1>>", GS(UVSPF_QUEST_AD1_3)),	1},
	},
	AD2 = {	--944	(1-2 only)
		{4868,  605, zf("<<t:1>>", GS(UVSPF_QUEST_AD2_1)),	1},
		{4386,  606, zf("<<t:1>>", GS(UVSPF_QUEST_AD2_2)),	1},
		{4885,  607, zf("<<t:1>>", GS(UVSPF_QUEST_AD2_3)),	1},
	},
	AD3 = {	--945
		{4750,  510, zf("<<t:1>>", GS(UVSPF_QUEST_AD3_1)),	1},
		{4765,  511, zf("<<t:1>>", GS(UVSPF_QUEST_AD3_2)),	1},
		{4690,  512, zf("<<t:1>>", GS(UVSPF_QUEST_AD3_3)),	1},
	},
	AD4 = {	--946
		{4337,    0, zf("<<t:1>>", GS(UVSPF_QUEST_AD4_1)),	1},
		{4452,  283, zf("<<t:1>>", GS(UVSPF_QUEST_AD4_2)),	1},
		{4143,  285, zf("<<t:1>>", GS(UVSPF_QUEST_AD4_3)),	1},
	},
	AD5 = {	--947
		{4712,    0, zf("<<t:1>>", GS(UVSPF_QUEST_AD5_1)),	1},
		{4479,  537, zf("<<t:1>>", GS(UVSPF_QUEST_AD5_2)),	1},
		{4720,  538, zf("<<t:1>>", GS(UVSPF_QUEST_AD5_3)),	1},
	},
	CC = {	--2064
		{6050, 2050, zf("<<t:1>>", GS(UVSPF_QUEST_CC_1)),	1},
		{6057, 2058, zf("<<t:1>>", GS(UVSPF_QUEST_CC_2)),	1},
		{6063, 2059, zf("<<t:1>>", GS(UVSPF_QUEST_CC_3)),	1},
		{6025, 2060, zf("<<t:1>>", GS(UVSPF_QUEST_CC_4)),	1},
		{6052, 2061, zf("<<t:1>>", GS(UVSPF_QUEST_CC_5)),	1},
		{6046, 2062, zf("<<t:1>>", GS(UVSPF_QUEST_CC_6)),	1},
		{6047, 2063, zf("<<t:1>>", GS(UVSPF_QUEST_CC_7)),	1},
		{6048, 2064, zf("<<t:1>>", GS(UVSPF_QUEST_CC_8)),	1},
	},
	CH = {	--957
		{4602,  612, zf("<<t:1>>", GS(UVSPF_QUEST_CH_1)),	1},
		{4730,  613, zf("<<t:1>>", GS(UVSPF_QUEST_CH_2)),	1},
		{4758,  614, zf("<<t:1>>", GS(UVSPF_QUEST_CH_3)),	1},
	},
	DB = {	--1444
		{5540, 1436, zf("<<t:1>>", GS(UVSPF_QUEST_DB_1)),	1},
		{5595, 1438, zf("<<t:1>>", GS(UVSPF_QUEST_DB_2)),	1},
		{5599, 1439, zf("<<t:1>>", GS(UVSPF_QUEST_DB_3)),	1},
		{5596, 1440, zf("<<t:1>>", GS(UVSPF_QUEST_DB_4)),	1},
		{5567, 1441, zf("<<t:1>>", GS(UVSPF_QUEST_DB_5)),	1},
		{5597, 1442, zf("<<t:1>>", GS(UVSPF_QUEST_DB_6)),	1},
		{5598, 1443, zf("<<t:1>>", GS(UVSPF_QUEST_DB_7)),	1},
		{5600, 1444, zf("<<t:1>>", GS(UVSPF_QUEST_DB_8)),	1},
	},
	DC1 = {	--953
		{3006,    0, zf("<<t:1>>", GS(UVSPF_QUEST_DC1_1)),	1},
		{3235,   30, zf("<<t:1>>", GS(UVSPF_QUEST_DC1_2)),	1},
		{3267,   28, zf("<<t:1>>", GS(UVSPF_QUEST_DC1_3)),	1},
		{3379,   31, zf("<<t:1>>", GS(UVSPF_QUEST_DC1_4)),	1},
	},
	DC2 = {	--954
		{ 467,  154, zf("<<t:1>>", GS(UVSPF_QUEST_DC2_1)),	1},
		{1633,  155, zf("<<t:1>>", GS(UVSPF_QUEST_DC2_2)),	1},
		{ 575,    0, zf("<<t:1>>", GS(UVSPF_QUEST_DC2_3)),	1},
	},
	DC3 = {	--955
		{ 465,  589, zf("<<t:1>>", GS(UVSPF_QUEST_DC3_1)),	1},
		{4972,  590, zf("<<t:1>>", GS(UVSPF_QUEST_DC3_2)),	1},
		{4884,  591, zf("<<t:1>>", GS(UVSPF_QUEST_DC3_3)),	1},
	},
	DC4 = {	--956
		{2192,  516, zf("<<t:1>>", GS(UVSPF_QUEST_DC4_1)),	1},
		{2222,  517, zf("<<t:1>>", GS(UVSPF_QUEST_DC4_2)),	1},
		{2997,  956, zf("<<t:1>>", GS(UVSPF_QUEST_DC4_3)),	1},
	},
	DC5 = {	--958
		{4891,    0, zf("<<t:1>>", GS(UVSPF_QUEST_DC5_1)),	1},
		{4912,  146, zf("<<t:1>>", GS(UVSPF_QUEST_DC5_2)),	1},
		{4960,  147, zf("<<t:1>>", GS(UVSPF_QUEST_DC5_3)),	1},
	},
	EO = {
		{6324,    0, zf("<<t:1>>", GS(UVSPF_QUEST_EO)),		1},
	},
	EP1 = {	--948
		{3735,  201, zf("<<t:1>>", GS(UVSPF_QUEST_EP1_1)),	1},
		{3634,  204, zf("<<t:1>>", GS(UVSPF_QUEST_EP1_2)),	1},
		{3868,  209, zf("<<t:1>>", GS(UVSPF_QUEST_EP1_3)),	1},
	},
	EP2 = {	--949
		{3797,  363, zf("<<t:1>>", GS(UVSPF_QUEST_EP2_1)),	1},
		{3817,  364, zf("<<t:1>>", GS(UVSPF_QUEST_EP2_2)),	1},
		{3831,  365, zf("<<t:1>>", GS(UVSPF_QUEST_EP2_3)),	1},
	},
	EP3 = {	--950
		{4590,  184, zf("<<t:1>>", GS(UVSPF_QUEST_EP3_1)),	1},
		{4606,  185, zf("<<t:1>>", GS(UVSPF_QUEST_EP3_2)),	1},
		{3910,  186, zf("<<t:1>>", GS(UVSPF_QUEST_EP3_2)),	1},
	},
	EP4 = {	--951
		{4061,    0, zf("<<t:1>>", GS(UVSPF_QUEST_EP4_1)),	1},
		{4115,    0, zf("<<t:1>>", GS(UVSPF_QUEST_EP4_2)),	1},
		{4117,  599, zf("<<t:1>>", GS(UVSPF_QUEST_EP4_3)),	1},
	},
	EP5 = {	--952
		{3968,  335, zf("<<t:1>>", GS(UVSPF_QUEST_EP5_1)),	1},
		{4139,  336, zf("<<t:1>>", GS(UVSPF_QUEST_EP5_2)),	1},
		{4188,  337, zf("<<t:1>>", GS(UVSPF_QUEST_EP5_3)),	1},
	},
	GD = {
		BC1 = { 1, 4107,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_BC1)),	zf("<<C:1>>", GZNBId(tempZId.ZN.AD1)),	zf("<<C:1>>", GZNBId(tempZId.GDN.BC1))},
		BC2 = { 2, 4597,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_BC2)),	zf("<<C:1>>", GZNBId(tempZId.ZN.AD1)),	zf("<<C:1>>", GZNBId(tempZId.GDN.BC2))},
		EH1 = { 3, 4336,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_EH1)),	zf("<<C:1>>", GZNBId(tempZId.ZN.AD2)),	zf("<<C:1>>", GZNBId(tempZId.GDN.EH1))},
		EH2 = { 4, 4675,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_EH2)),	zf("<<C:1>>", GZNBId(tempZId.ZN.AD2)),	zf("<<C:1>>", GZNBId(tempZId.GDN.EH2))},
		CA1 = { 5, 4778,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_CA1)),	zf("<<C:1>>", GZNBId(tempZId.ZN.AD3)),	zf("<<C:1>>", GZNBId(tempZId.GDN.CA1))},
		CA2 = { 6, 5120,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_CA2)),	zf("<<C:1>>", GZNBId(tempZId.ZN.AD3)),	zf("<<C:1>>", GZNBId(tempZId.GDN.CA2))},
		TI  = { 7, 4538,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_TI)),	zf("<<C:1>>", GZNBId(tempZId.ZN.AD4)),	zf("<<C:1>>", GZNBId(tempZId.GDN.TI))},
		SW  = { 8, 4733,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_SW)),	zf("<<C:1>>", GZNBId(tempZId.ZN.AD5)),	zf("<<C:1>>", GZNBId(tempZId.GDN.SW))},
		SC1 = { 9, 4054,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_SC1)),	zf("<<C:1>>", GZNBId(tempZId.ZN.DC1)),	zf("<<C:1>>", GZNBId(tempZId.GDN.SC1))},
		SC2 = {10, 4555,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_SC2)),	zf("<<C:1>>", GZNBId(tempZId.ZN.DC1)),	zf("<<C:1>>", GZNBId(tempZId.GDN.SC2))},
		WS1 = {11, 4246,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_WS1)),	zf("<<C:1>>", GZNBId(tempZId.ZN.DC2)),	zf("<<C:1>>", GZNBId(tempZId.GDN.WS1))},
		WS2 = {12, 4813,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_WS2)),	zf("<<C:1>>", GZNBId(tempZId.ZN.DC2)),	zf("<<C:1>>", GZNBId(tempZId.GDN.WS2))},
		CH1 = {13, 4379,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_CH1)),	zf("<<C:1>>", GZNBId(tempZId.ZN.DC3)),	zf("<<C:1>>", GZNBId(tempZId.GDN.CH1))},
		CH2 = {14, 5113,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_CH2)),	zf("<<C:1>>", GZNBId(tempZId.ZN.DC3)),	zf("<<C:1>>", GZNBId(tempZId.GDN.CH2))},
		VF  = {15, 4432,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_VF)),	zf("<<C:1>>", GZNBId(tempZId.ZN.DC4)),	zf("<<C:1>>", GZNBId(tempZId.GDN.VF))},
		BH  = {16, 4589,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_BH)),	zf("<<C:1>>", GZNBId(tempZId.ZN.DC5)),	zf("<<C:1>>", GZNBId(tempZId.GDN.BH))},
		FG1 = {17, 3993,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_FG1)),	zf("<<C:1>>", GZNBId(tempZId.ZN.EP1)),	zf("<<C:1>>", GZNBId(tempZId.GDN.FG1))},
		FG2 = {18, 4303,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_FG2)),	zf("<<C:1>>", GZNBId(tempZId.ZN.EP1)),	zf("<<C:1>>", GZNBId(tempZId.GDN.FG2))},
		DC1 = {19, 4145,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_DC1)),	zf("<<C:1>>", GZNBId(tempZId.ZN.EP2)),	zf("<<C:1>>", GZNBId(tempZId.GDN.DC1))},
		DC2 = {20, 4641,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_DC2)),	zf("<<C:1>>", GZNBId(tempZId.ZN.EP2)),	zf("<<C:1>>", GZNBId(tempZId.GDN.DC2))},
		AC  = {21, 4202,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_AC)),	zf("<<C:1>>", GZNBId(tempZId.ZN.EP3)),	zf("<<C:1>>", GZNBId(tempZId.GDN.AC))},
		DK  = {22, 4346,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_DK)),	zf("<<C:1>>", GZNBId(tempZId.ZN.EP4)),	zf("<<C:1>>", GZNBId(tempZId.GDN.DK))},
		BC  = {23, 4469,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_BC)),	zf("<<C:1>>", GZNBId(tempZId.ZN.EP5)),	zf("<<C:1>>", GZNBId(tempZId.GDN.BC))},
		VM  = {24, 4822,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_VM)),	zf("<<C:1>>", GZNBId(tempZId.ZN.CH)),	zf("<<C:1>>", GZNBId(tempZId.GDN.VM))},
		ICP = {25, 5136,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_ICP)),	zf("<<C:1>>", GZNBId(tempZId.ZN.CYD)),	zf("<<C:1>>", GZNBId(tempZId.GDN.ICP))},
		WGT = {26, 5342,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_WGT)),	zf("<<C:1>>", GZNBId(tempZId.ZN.CYD)),	zf("<<C:1>>", GZNBId(tempZId.GDN.WGT))},
		CS  = {27, 5702,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_CS)),	zf("<<C:1>>", GZNBId(tempZId.ZN.EP3)),	zf("<<C:1>>", GZNBId(tempZId.GDN.CS))},
		RM  = {28, 5403,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_RM)),	zf("<<C:1>>", GZNBId(tempZId.ZN.EP3)),	zf("<<C:1>>", GZNBId(tempZId.GDN.RM))},
		BF  = {29, 5889,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_BF)),	zf("<<C:1>>", GZNBId(tempZId.ZN.CL)),	zf("<<C:1>>", GZNBId(tempZId.GDN.BF))},
		FH  = {30, 5891,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_FH)),	zf("<<C:1>>", GZNBId(tempZId.ZN.CL)),	zf("<<C:1>>", GZNBId(tempZId.GDN.FH))},
		FL	= {31, 6064,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_FL)),	zf("<<C:1>>", GZNBId(tempZId.ZN.DC5)),	zf("<<C:1>>", GZNBId(tempZId.GDN.FL))},
		SP	= {32, 6065,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_SP)),	zf("<<C:1>>", GZNBId(tempZId.ZN.DC2)),	zf("<<C:1>>", GZNBId(tempZId.GDN.SP))},
		MHK = {33, 6186,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_MHK)),	zf("<<C:1>>", GZNBId(tempZId.ZN.AD5)),	zf("<<C:1>>", GZNBId(tempZId.GDN.MHK))},
		MOS = {34, 6188,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_MOS)),	zf("<<C:1>>", GZNBId(tempZId.ZN.AD3)),	zf("<<C:1>>", GZNBId(tempZId.GDN.MOS))},
		DoM = {35, 6251,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_DoM)),	zf("<<C:1>>", GZNBId(tempZId.ZN.GC)),	zf("<<C:1>>", GZNBId(tempZId.GDN.DoM))},
		FV  = {36, 6249,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_FV)),	zf("<<C:1>>", GZNBId(tempZId.ZN.EP4)),	zf("<<C:1>>", GZNBId(tempZId.GDN.FV))},
		LM  = {37, 6351,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_LM)),	zf("<<C:1>>", GZNBId(tempZId.ZN.AD2)),	zf("<<C:1>>", GZNBId(tempZId.GDN.LM))},
		MF  = {38, 6349,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_MF)),	zf("<<C:1>>", GZNBId(tempZId.ZN.NE)),	zf("<<C:1>>", GZNBId(tempZId.GDN.MF))},
		IR  = {39, 6414,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_IR)),	zf("<<C:1>>", GZNBId(tempZId.ZN.RO)),	zf("<<C:1>>", GZNBId(tempZId.GDN.IR))},
		UG  = {40, 6416,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_UG)),	zf("<<C:1>>", GZNBId(tempZId.ZN.DC5)),	zf("<<C:1>>", GZNBId(tempZId.GDN.UG))},
		SG  = {41, 6505,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_SG)),	zf("<<C:1>>", GZNBId(tempZId.ZN.BGC)),	zf("<<C:1>>", GZNBId(tempZId.GDN.SG))},
		CT  = {42, 6507,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_CT)),	zf("<<C:1>>", GZNBId(tempZId.ZN.WS)),	zf("<<C:1>>", GZNBId(tempZId.GDN.CT))},
		CD  = {43, 6578,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_CD)),	zf("<<C:1>>", GZNBId(tempZId.ZN.EP2)),	zf("<<C:1>>", GZNBId(tempZId.GDN.CD))},
		BDV = {44, 6576,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GD_BDV)),	zf("<<C:1>>", GZNBId(tempZId.ZN.GC)),	zf("<<C:1>>", GZNBId(tempZId.GDN.BDV))},
	},
	IC = {	--1175
		{5482, 1175, zf("<<t:1>>", GS(UVSPF_QUEST_IC)),		1},
	},
	MM = {	--2339
		{6246, 2333, zf("<<t:1>>", GS(UVSPF_QUEST_MM_1)),	1},
		{6266, 2334, zf("<<t:1>>", GS(UVSPF_QUEST_MM_2)),	1},
		{6241, 2335, zf("<<t:1>>", GS(UVSPF_QUEST_MM_3)),	1},
		{6259, 2336, zf("<<t:1>>", GS(UVSPF_QUEST_MM_4)),	1},
		{6243, 2337, zf("<<t:1>>", GS(UVSPF_QUEST_MM_5)),	1},
		{6244, 2338, zf("<<t:1>>", GS(UVSPF_QUEST_MM_6)),	1},
		{6245, 2339, zf("<<t:1>>", GS(UVSPF_QUEST_MM_7)),	1},
	},
	MW = {
		{6003, 1852, zf("<<t:1>>", GS(UVSPF_QUEST_MW_1)),	1},
		{5922, 1869, zf("<<t:1>>", GS(UVSPF_QUEST_MW_2)),	1},
		{5948, 1870, zf("<<t:1>>", GS(UVSPF_QUEST_MW_3)),	1},
	},
	MO = {
		{5804,    0, zf("<<t:1>>", GS(UVSPF_QUEST_MO)),		1},
	},
	MQ = {	--1003
		{4296,  993, zf("<<t:1>>", GS(UVSPF_QUEST_MQ_1)),	1},
		{4831,  994, zf("<<t:1>>", GS(UVSPF_QUEST_MQ_2)),	1},
		{4474,  995, zf("<<t:1>>", GS(UVSPF_QUEST_MQ_3)),	1},
		{4552,  996, zf("<<t:1>>", GS(UVSPF_QUEST_MQ_4)),	1},
		{4607,  997, zf("<<t:1>>", GS(UVSPF_QUEST_MQ_5)),	1},
		{4764,  998, zf("<<t:1>>", GS(UVSPF_QUEST_MQ_6)),	1},
		{4836,  999, zf("<<t:1>>", GS(UVSPF_QUEST_MQ_7)),	1},
		{4837, 1000, zf("<<t:1>>", GS(UVSPF_QUEST_MQ_8)),	1},
		{4867, 1001, zf("<<t:1>>", GS(UVSPF_QUEST_MQ_9)),	1},
		{4832, 1002, zf("<<t:1>>", GS(UVSPF_QUEST_MQ_10)),	1},
		{4847, 1003, zf("<<t:1>>", GS(UVSPF_QUEST_MQ_11)),	1},
	},
	NE = {	--2488
		{6336, 2482, zf("<<t:1>>", GS(UVSPF_QUEST_NE_1)),	1},
		{6304, 2485, zf("<<t:1>>", GS(UVSPF_QUEST_NE_2)),	1},
		{6315, 2488, zf("<<t:1>>", GS(UVSPF_QUEST_NE_3)),	1},
	},
	RO = {	--1260
		{5447, 1325, zf("<<t:1>>", GS(UVSPF_QUEST_RO_1)),	1},
		{5468, 1326, zf("<<t:1>>", GS(UVSPF_QUEST_RO_2)),	1},
		{5481, 1327, zf("<<t:1>>", GS(UVSPF_QUEST_RO_3)),	1},
	},
	TG = {	--1363
		{5531, 1371, zf("<<t:1>>", GS(UVSPF_QUEST_TG_1)),	1},
		{5534, 1360, zf("<<t:1>>", GS(UVSPF_QUEST_TG_2)),	1},
		{5532, 1370, zf("<<t:1>>", GS(UVSPF_QUEST_TG_3)),	1},
		{5556, 1361, zf("<<t:1>>", GS(UVSPF_QUEST_TG_4)),	1},
		{5549, 1362, zf("<<t:1>>", GS(UVSPF_QUEST_TG_5)),	1},
		{5545, 1363, zf("<<t:1>>", GS(UVSPF_QUEST_TG_6)),	1},
	},
	SE = {	--2604
		{6401, 2596, zf("<<t:1>>", GS(UVSPF_QUEST_SE_1)),	1},
		{6409,    0, zf("<<t:1>>", GS(UVSPF_QUEST_SE_2)),	1},
		{6394, 2597, zf("<<t:1>>", GS(UVSPF_QUEST_SE_3)),	1},
		{6399, 2598, zf("<<t:1>>", GS(UVSPF_QUEST_SE_4)),	1},
		{6403, 2599, zf("<<t:1>>", GS(UVSPF_QUEST_SE_5)),	1},
		{6404, 2600, zf("<<t:1>>", GS(UVSPF_QUEST_SE_6)),	1},
		{6393, 2602, zf("<<t:1>>", GS(UVSPF_QUEST_SE_7)),	1},
		{6397, 2603, zf("<<t:1>>", GS(UVSPF_QUEST_SE_8)),	1},
		{6402, 2604, zf("<<t:1>>", GS(UVSPF_QUEST_SE_9)),	1},
	},
	SO = {
		{6143,    0, zf("<<t:1>>", GS(UVSPF_QUEST_SO)),		1},
	},
	SU = {	--2208
		{6132, 2203, zf("<<t:1>>", GS(UVSPF_QUEST_SU_1)),	1},
		{6113, 2206, zf("<<t:1>>", GS(UVSPF_QUEST_SU_2)),	1},
		{6126, 2208, zf("<<t:1>>", GS(UVSPF_QUEST_SU_3)),	1},
	},
	WS = {	--2722
		{6476, 2720, zf("<<t:1>>", GS(UVSPF_QUEST_WS_1)),	1},
		{6466, 2722, zf("<<t:1>>", GS(UVSPF_QUEST_WS_2)),	1},
		{6481, 2725, zf("<<t:1>>", GS(UVSPF_QUEST_WS_3)),	1},
	},
	TR = {	--2957
		{6550, 2930, zf("<<t:1>>", GS(UVSPF_QUEST_TR_1)),	1},
		{6551, 2931, zf("<<t:1>>", GS(UVSPF_QUEST_TR_2)),	1},
		{6547, 2932, zf("<<t:1>>", GS(UVSPF_QUEST_TR_3)),	1},
		{6548, 2933, zf("<<t:1>>", GS(UVSPF_QUEST_TR_4)),	1},
		{6554, 2934, zf("<<t:1>>", GS(UVSPF_QUEST_TR_5)),	1},
		{6566, 2935, zf("<<t:1>>", GS(UVSPF_QUEST_TR_6)),	1},
	},
	BW = {	--3056
		{6616, 3049, zf("<<t:1>>", GS(UVSPF_QUEST_BW_1)),	1},
		{6619, 3051, zf("<<t:1>>", GS(UVSPF_QUEST_BW_2)),	1},
		{6660, 3054, zf("<<t:1>>", GS(UVSPF_QUEST_BW_3)),	1},
	},
	GO = {
		{6455,    0, zf("<<t:1>>", GS(UVSPF_QUEST_GO)),		1},
		},
	BO = {
		{6646,    0, zf("<<t:1>>", GS(UVSPF_QUEST_BO)),		1},
		},
	PD = {  --Public Dungeons
		AD1	= { 1,  468, zf("<<C:1>>", GZNBId(tempZId.ZN.AD1)), zf("<<C:1>>", GZNBId(tempZId.PDN.AD1))},
		AD2	= { 2,  470, zf("<<C:1>>", GZNBId(tempZId.ZN.AD2)), zf("<<C:1>>", GZNBId(tempZId.PDN.AD2))},
		AD3	= { 3,  445, zf("<<C:1>>", GZNBId(tempZId.ZN.AD3)), zf("<<C:1>>", GZNBId(tempZId.PDN.AD3))},
		AD4	= { 4,  460, zf("<<C:1>>", GZNBId(tempZId.ZN.AD4)), zf("<<C:1>>", GZNBId(tempZId.PDN.AD4))},
		AD5	= { 5,  469, zf("<<C:1>>", GZNBId(tempZId.ZN.AD5)), zf("<<C:1>>", GZNBId(tempZId.PDN.AD5))},
		DC1	= { 6,  380, zf("<<C:1>>", GZNBId(tempZId.ZN.DC1)), zf("<<C:1>>", GZNBId(tempZId.PDN.DC1))},
		DC2	= { 7,  714, zf("<<C:1>>", GZNBId(tempZId.ZN.DC2)), zf("<<C:1>>", GZNBId(tempZId.PDN.DC2))},
		DC3	= { 8,  713, zf("<<C:1>>", GZNBId(tempZId.ZN.DC3)), zf("<<C:1>>", GZNBId(tempZId.PDN.DC3))},
		DC4	= { 9,  707, zf("<<C:1>>", GZNBId(tempZId.ZN.DC4)), zf("<<C:1>>", GZNBId(tempZId.PDN.DC4))},
		DC5	= {10,  708, zf("<<C:1>>", GZNBId(tempZId.ZN.DC5)), zf("<<C:1>>", GZNBId(tempZId.PDN.DC5))},
		EP1	= {11,  379, zf("<<C:1>>", GZNBId(tempZId.ZN.EP1)), zf("<<C:1>>", GZNBId(tempZId.PDN.EP1))},
		EP2	= {12,  388, zf("<<C:1>>", GZNBId(tempZId.ZN.EP2)), zf("<<C:1>>", GZNBId(tempZId.PDN.EP2))},
		EP3	= {13,  372, zf("<<C:1>>", GZNBId(tempZId.ZN.EP3)), zf("<<C:1>>", GZNBId(tempZId.PDN.EP3))},
		EP4	= {14,  381, zf("<<C:1>>", GZNBId(tempZId.ZN.EP4)), zf("<<C:1>>", GZNBId(tempZId.PDN.EP4))},
		EP5	= {15,  371, zf("<<C:1>>", GZNBId(tempZId.ZN.EP5)), zf("<<C:1>>", GZNBId(tempZId.PDN.EP5))},
		CH	= {16,  874, zf("<<C:1>>", GZNBId(tempZId.ZN.CH)),  zf("<<C:1>>", GZNBId(tempZId.PDN.CH))},
		VFW	= {17, 1855, zf("<<C:1>>", GZNBId(tempZId.ZN.VV)),  zf("<<C:1>>", GZNBId(tempZId.PDN.VFW))},
		VNC	= {18, 1846, zf("<<C:1>>", GZNBId(tempZId.ZN.VV)),  zf("<<C:1>>", GZNBId(tempZId.PDN.VNC))},
		WOO	= {19, 1238, zf("<<C:1>>", GZNBId(tempZId.ZN.RO)),  zf("<<C:1>>", GZNBId(tempZId.PDN.WOO))},
		WRK	= {20, 1235, zf("<<C:1>>", GZNBId(tempZId.ZN.RO)),  zf("<<C:1>>", GZNBId(tempZId.PDN.WRK))},
		SKW	= {21, 2096, zf("<<C:1>>", GZNBId(tempZId.ZN.SU)),  zf("<<C:1>>", GZNBId(tempZId.PDN.SKW))},
		SSH	= {22, 2095, zf("<<C:1>>", GZNBId(tempZId.ZN.SU)),  zf("<<C:1>>", GZNBId(tempZId.PDN.SSH))},
		RN	= {23, 2444, zf("<<C:1>>", GZNBId(tempZId.ZN.NE)),  zf("<<C:1>>", GZNBId(tempZId.PDN.RN))},
		OC	= {24, 2445, zf("<<C:1>>", GZNBId(tempZId.ZN.NE)),  zf("<<C:1>>", GZNBId(tempZId.PDN.OC))},
    	LT  = {25, 2714, zf("<<C:1>>", GZNBId(tempZId.ZN.WS)),  zf("<<C:1>>", GZNBId(tempZId.PDN.LT))},
    	NK  = {26, 2715, zf("<<C:1>>", GZNBId(tempZId.ZN.BGC)), zf("<<C:1>>", GZNBId(tempZId.PDN.NK))},
    	ZA  = {27, 2995, zf("<<C:1>>", GZNBId(tempZId.ZN.BW)),  zf("<<C:1>>", GZNBId(tempZId.PDN.ZA))},
    	TSH = {28, 2994, zf("<<C:1>>", GZNBId(tempZId.ZN.BW)),  zf("<<C:1>>", GZNBId(tempZId.PDN.TSH))},
	},
	SS = {
		MQ	 = { 1, 2521, zf("<<C:1>>", GZNBId(tempZId.ZN.WP))},
		AD0	 = { 2,  431, zf("<<C:1>>", GZNBId(tempZId.ZN.AD0))},
		AD1	 = { 3,  695, zf("<<C:1>>", GZNBId(tempZId.ZN.AD1))},
		AD2	 = { 4,  682, zf("<<C:1>>", GZNBId(tempZId.ZN.AD2))},
		AD3	 = { 5,  683, zf("<<C:1>>", GZNBId(tempZId.ZN.AD3))},
		AD4	 = { 6,  684, zf("<<C:1>>", GZNBId(tempZId.ZN.AD4))},
		AD5	 = { 7,  685, zf("<<C:1>>", GZNBId(tempZId.ZN.AD5))},
		DC0a = { 8,  408, zf("<<C:1>>", GZNBId(tempZId.ZN.DC0A))},
		DC0b = { 9,  407, zf("<<C:1>>", GZNBId(tempZId.ZN.DC0B))},
		DC1	 = {10,  409, zf("<<C:1>>", GZNBId(tempZId.ZN.DC1))},
		DC2	 = {11,  515, zf("<<C:1>>", GZNBId(tempZId.ZN.DC2))},
		DC3	 = {12,  554, zf("<<C:1>>", GZNBId(tempZId.ZN.DC3))},
		DC4	 = {13,  556, zf("<<C:1>>", GZNBId(tempZId.ZN.DC4))},
		DC5	 = {14,  557, zf("<<C:1>>", GZNBId(tempZId.ZN.DC5))},
		EP0a = {15,  405, zf("<<C:1>>", GZNBId(tempZId.ZN.EP0A))},
		EP0b = {16,  398, zf("<<C:1>>", GZNBId(tempZId.ZN.EP0B))},
		EP1	 = {17,  397, zf("<<C:1>>", GZNBId(tempZId.ZN.EP1))},
		EP2	 = {18,  547, zf("<<C:1>>", GZNBId(tempZId.ZN.EP2))},
		EP3	 = {19,  687, zf("<<C:1>>", GZNBId(tempZId.ZN.EP3))},
		EP4	 = {20,  688, zf("<<C:1>>", GZNBId(tempZId.ZN.EP4))},
		EP5	 = {21,  689, zf("<<C:1>>", GZNBId(tempZId.ZN.EP5))},
		CH	 = {22,  686, zf("<<C:1>>", GZNBId(tempZId.ZN.CH))},
		CAD	 = {23,  694, zf("<<C:1>>", GZNBId(tempZId.ZN.CAD))},
		CDC	 = {24,  693, zf("<<C:1>>", GZNBId(tempZId.ZN.CDC))},
		CEP	 = {25,  692, zf("<<C:1>>", GZNBId(tempZId.ZN.CEP))},
		CMT	 = {26,  748, zf("<<C:1>>", GZNBId(tempZId.ZN.CMT))},
		LCL	 = {27,  727, zf("<<C:1>>", GZNBId(tempZId.ZN.LCL))},
		UCL	 = {28,  912, zf("<<C:1>>", GZNBId(tempZId.ZN.UCL))},
		IC	 = {29, 1160, zf("<<C:1>>", GZNBId(tempZId.ZN.IC))},
		WR	 = {30, 1320, zf("<<C:1>>", GZNBId(tempZId.ZN.RO))},
		HB	 = {31, 1347, zf("<<C:1>>", GZNBId(tempZId.ZN.HB))},
		GC	 = {32, 1342, zf("<<C:1>>", GZNBId(tempZId.ZN.GC))},
		VV	 = {33, 1843, zf("<<C:1>>", GZNBId(tempZId.ZN.VV))},
		CC	 = {34, 1844, zf("<<C:1>>", GZNBId(tempZId.ZN.CC))},
		SU	 = {35, 1845, zf("<<C:1>>", GZNBId(tempZId.ZN.SU))},
		MM	 = {36, 2291, zf("<<C:1>>", GZNBId(tempZId.ZN.MM))},
		NE	 = {37, 2461, zf("<<C:1>>", GZNBId(tempZId.ZN.NE))},
		SE	 = {38, 2562, zf("<<C:1>>", GZNBId(tempZId.ZN.SE))},
        WS   = {39, 2687, zf("<<C:1>>", GZNBId(tempZId.ZN.WS))},
        TR   = {40, 2857, zf("<<C:1>>", GZNBId(tempZId.ZN.TR))},
        BW   = {41, 2982, zf("<<C:1>>", GZNBId(tempZId.ZN.TR))},
	},
	racialLineIds = {
		--RaceId	SkillLineId	Race
		[1]  = 60,		--Breton
		[2]  = 62,		--Redguard
		[3]  = 52,		--Orc
		[4]  = 64,		--Dark Elf
		[5]  = 65,		--Nord
		[6]  = 63,		--Argonian
		[7]  = 56,		--High Elf
		[8]  = 57,		--Wood Elf
		[9]  = 58,		--Khajiit
		[10] = 59,		--Imperial
	},
}


local function UVSPF_RedText(text)	return "|cFF0000"..tostring(text).."|r" end
local function UVSPF_GreenText(text)	return "|c00FF00"..tostring(text).."|r" end
local function UVSPF_BlueText(text)	return "|c0000FF"..tostring(text).."|r" end

local function UVSPF_rgbToHex(rgb)
	local hexStr = '|c'
	for _, v in pairs(rgb) do
		local hex = ''
		local tmpV = math.floor((255 * v) + 0.5)
		while(tmpV > 0) do
			local idx = math.fmod(tmpV, 16) + 1
			tmpV = math.floor(tmpV / 16)
			hex = string.sub('0123456789ABCDEF', idx, idx) .. hex
		end
		hex = (string.len(hex) == 0 and '00' or (string.len(hex) == 1 and '0' .. hex or hex))
		hexStr = hexStr .. hex
	end
	return hexStr
end

local function UVSPF_UpdateAllSavedVars()
	if(UVSPF.sVar.ptsData[selectedChar] == nil) then UVSPF.sVar.ptsData[selectedChar] = {} end
	UVSPF.sVar.ptsData[selectedChar] = UVSPF_LTF:CopyTable(UVSPF.ptsData)
end

local function UVSPF_ResetSelectedCharacter()
	if(selectedChar ~= GCCId()) then
		UVSPF_GUI_Header_CharList.comboBox = UVSPF_GUI_Header_CharList.comboBox or ZO_ComboBox_ObjectFromContainer(UVSPF_GUI_Header_CharList)
		local UVSPF_comboBox = UVSPF_GUI_Header_CharList.comboBox
		
		local name, id = nil, nil
		for k,_ in ipairs(UVSPF.charData) do
			name, _, _, _, _, _, id, _ = GetCharacterInfo(k)
			if(GCCId() == UVSPF.charData[k].charId) then
				currentCharName = UVSPF.charData[k].charName
				selectedChar = UVSPF.charData[k].charId
				UVSPF_comboBox:SetSelectedItem(currentCharName)
			end
		end
	end
end

local function GetQuestTooltipText(zone)
	quests = ""
	for i = 1, #UVSPF.data[zone] do
		quests = quests..(selectedChar == GCCId() and (UVSPF.data[zone][i][2] == 0 and GCQI(UVSPF.data[zone][i][1]) ~= "" or IAchC(UVSPF.data[zone][i][2]))
					and "|l0:1:0:-25%:2:ffffff|l"..UVSPF.data[zone][i][3].."|l"
					or UVSPF.data[zone][i][3])..(i < #UVSPF.data[zone] and "\n" or "")
	end
	return quests
end

local function GetGDQuestTooltipText(dungeon)
	if(selectedChar == GCCId() and GCQI(UVSPF.data.GD[dungeon][2]) ~= "") then
		return "|l0:1:0:-25%:2:ffffff|l"..UVSPF.data.GD[dungeon][4].."|l"
	else
		return UVSPF.data.GD[dungeon][4]
	end
end

local function GetAchLink(achId)
	return GetAchievementLink(achId, LINK_TYPE_ACHIEVEMENT)
end

local function UVSPF_UpdateGUITable()
	questTooltips = {
		WP	 = GS(UVSPF_QUEST_NONE),
		AD0	 = GS(UVSPF_QUEST_NONE),
		AD1  = GetQuestTooltipText("AD1"),
		AD2  = GetQuestTooltipText("AD2"),
		AD3  = GetQuestTooltipText("AD3"),
		AD4  = GetQuestTooltipText("AD4"),
		AD5  = GetQuestTooltipText("AD5"),
		CC   = GetQuestTooltipText("CC"),
		CH   = GetQuestTooltipText("CH"),
		CAD	 = GS(UVSPF_QUEST_NONE),
		CDC	 = GS(UVSPF_QUEST_NONE),
		CEP	 = GS(UVSPF_QUEST_NONE),
		CMT	 = GS(UVSPF_QUEST_NONE),
		DB   = GetQuestTooltipText("DB"),
		DC0a = GS(UVSPF_QUEST_NONE),
		DC0b = GS(UVSPF_QUEST_NONE),
		DC1	 = GetQuestTooltipText("DC1"),
		DC2	 = GetQuestTooltipText("DC2"),
		DC3	 = GetQuestTooltipText("DC3"),
		DC4	 = GetQuestTooltipText("DC4"),
		DC5	 = GetQuestTooltipText("DC5"),
		EO	 = GetQuestTooltipText("EO"),
		EP0a = GS(UVSPF_QUEST_NONE),
		EP0b = GS(UVSPF_QUEST_NONE),
		EP1	 = GetQuestTooltipText("EP1"),
		EP2	 = GetQuestTooltipText("EP2"),
		EP3	 = GetQuestTooltipText("EP3"),
		EP4	 = GetQuestTooltipText("EP4"),
		EP5	 = GetQuestTooltipText("EP5"),
		IC	 = GetQuestTooltipText("IC"),
		LCL	 = GS(UVSPF_QUEST_NONE),
		UCL	 = GS(UVSPF_QUEST_NONE),
		MM	 = GetQuestTooltipText("MM"),
		MO	 = GetQuestTooltipText("MO"),
		MW	 = GetQuestTooltipText("MW"),
		MQ	 = GetQuestTooltipText("MQ"),
		NE	 = GetQuestTooltipText("NE"),
		RO	 = GetQuestTooltipText("RO"),
		SE	 = GetQuestTooltipText("SE"),
		SO	 = GetQuestTooltipText("SO"),
		TG	 = GetQuestTooltipText("TG"),
		SU	 = GetQuestTooltipText("SU"),
    	WS   = GetQuestTooltipText("WS"),
    	TR   = GetQuestTooltipText("TR"),
    	GO   = GetQuestTooltipText("GO"),
    	BW   = GetQuestTooltipText("BW"),
    	BO   = GetQuestTooltipText("BO"),
	}
	
	UVSPF.GUI = {
		GSP = {
			{1,  GS(UVSPF_GUI_CHAR_LEVEL),	UVSPF.ptsData.Level,	UVSPF.ptsTots.Level,	GS(UVSPF_QUEST_NA)},
			{2,  GS(UVSPF_GUI_MAIN_QUEST),	UVSPF.ptsData.MainQ,	UVSPF.ptsTots.MainQ,	questTooltips.MQ},
			{3,  GS(UVSPF_GUI_FOLIUM),		UVSPF.ptsData.FolDis,	UVSPF.ptsTots.FolDis,	GS(UVSPF_QUEST_NA)},
			{4,  GS(UVSPF_GUI_MW_CHAR),		UVSPF.ptsData.MWChar,	UVSPF.ptsTots.MWChar,	questTooltips.MO},
			{5,  GS(UVSPF_GUI_SU_CHAR),		UVSPF.ptsData.SUChar,	UVSPF.ptsTots.SUChar,	questTooltips.SO},
			{6,  GS(UVSPF_GUI_EW_CHAR),		UVSPF.ptsData.EWChar,	UVSPF.ptsTots.EWChar,	questTooltips.EO},
			{7,  GS(UVSPF_GUI_GM_CHAR),		UVSPF.ptsData.GMChar,	UVSPF.ptsTots.GMChar,	questTooltips.GO},
			{8,  GS(UVSPF_GUI_BW_CHAR),		UVSPF.ptsData.BWChar,	UVSPF.ptsTots.BWChar,	questTooltips.BO},
			{9,  GS(UVSPF_GUI_AVA_RANK),	UVSPF.ptsData.PvPRank,	UVSPF.ptsTots.PvPRank,	GS(UVSPF_QUEST_NA)},
			{10, GS(UVSPF_GUI_MAEL_ARENA),	UVSPF.ptsData.MaelAr,	UVSPF.ptsTots.MaelAr,	GS(UVSPF_QUEST_NA)},
			{11, GS(UVSPF_GUI_VAT_ARENA),	UVSPF.ptsData.VatAr,	UVSPF.ptsTots.VatAr,	GS(UVSPF_QUEST_NA)},
		},
		GSP_T = strF("%s: %d/%d", GS(UVSPF_GUI_TOTAL), UVSPF.ptsData.GenTot, UVSPF.ptsTots.GenTot),
		SQS = {
			{ 1, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.WP)),						UVSPF.ptsData.ZQ.WP,		UVSPF.ptsTots.ZQ.WP,		UVSPF.ptsData.SS.MQ,		UVSPF.ptsTots.SS.MQ,		questTooltips.WP},
			{ 2, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.AD0)),						UVSPF.ptsData.ZQ.AD0,	UVSPF.ptsTots.ZQ.AD0,	UVSPF.ptsData.SS.AD0,	UVSPF.ptsTots.SS.AD0,	questTooltips.AD0},
			{ 3, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.AD1)),						UVSPF.ptsData.ZQ.AD1,	UVSPF.ptsTots.ZQ.AD1,	UVSPF.ptsData.SS.AD1,	UVSPF.ptsTots.SS.AD1,	questTooltips.AD1},
			{ 4, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.AD2)),						UVSPF.ptsData.ZQ.AD2,	UVSPF.ptsTots.ZQ.AD2,	UVSPF.ptsData.SS.AD2,	UVSPF.ptsTots.SS.AD2,	questTooltips.AD2},
			{ 5, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.AD3)),						UVSPF.ptsData.ZQ.AD3,	UVSPF.ptsTots.ZQ.AD3,	UVSPF.ptsData.SS.AD3,	UVSPF.ptsTots.SS.AD3,	questTooltips.AD3},
			{ 6, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.AD4)),						UVSPF.ptsData.ZQ.AD4,	UVSPF.ptsTots.ZQ.AD4,	UVSPF.ptsData.SS.AD4,	UVSPF.ptsTots.SS.AD4,	questTooltips.AD4},
			{ 7, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.AD5)),						UVSPF.ptsData.ZQ.AD5,	UVSPF.ptsTots.ZQ.AD5,	UVSPF.ptsData.SS.AD5,	UVSPF.ptsTots.SS.AD5,	questTooltips.AD5},
			{ 8, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.DC0B)),						UVSPF.ptsData.ZQ.DC0b,	UVSPF.ptsTots.ZQ.DC0b,	UVSPF.ptsData.SS.DC0b,	UVSPF.ptsTots.SS.DC0b,	questTooltips.DC0b},
			{ 9, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.DC0A)),						UVSPF.ptsData.ZQ.DC0a,	UVSPF.ptsTots.ZQ.DC0a,	UVSPF.ptsData.SS.DC0a,	UVSPF.ptsTots.SS.DC0a,	questTooltips.DC0a},
			{10, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.DC1)),						UVSPF.ptsData.ZQ.DC1,	UVSPF.ptsTots.ZQ.DC1,	UVSPF.ptsData.SS.DC1,	UVSPF.ptsTots.SS.DC1,	questTooltips.DC1},
			{11, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.DC2)),						UVSPF.ptsData.ZQ.DC2,	UVSPF.ptsTots.ZQ.DC2,	UVSPF.ptsData.SS.DC2,	UVSPF.ptsTots.SS.DC2,	questTooltips.DC2},
			{12, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.DC3)),						UVSPF.ptsData.ZQ.DC3,	UVSPF.ptsTots.ZQ.DC3,	UVSPF.ptsData.SS.DC3,	UVSPF.ptsTots.SS.DC3,	questTooltips.DC3},
			{13, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.DC4)),						UVSPF.ptsData.ZQ.DC4,	UVSPF.ptsTots.ZQ.DC4,	UVSPF.ptsData.SS.DC4,	UVSPF.ptsTots.SS.DC4,	questTooltips.DC4},
			{14, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.DC5)),						UVSPF.ptsData.ZQ.DC5,	UVSPF.ptsTots.ZQ.DC5,	UVSPF.ptsData.SS.DC5,	UVSPF.ptsTots.SS.DC5,	questTooltips.DC5},
			{15, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.EP0B)),						UVSPF.ptsData.ZQ.EP0b,	UVSPF.ptsTots.ZQ.EP0b,	UVSPF.ptsData.SS.EP0b,	UVSPF.ptsTots.SS.EP0b,	questTooltips.EP0b},
			{16, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.EP0A)),						UVSPF.ptsData.ZQ.EP0a,	UVSPF.ptsTots.ZQ.EP0a,	UVSPF.ptsData.SS.EP0a,	UVSPF.ptsTots.SS.EP0a,	questTooltips.EP0a},
			{17, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.EP1)),						UVSPF.ptsData.ZQ.EP1,	UVSPF.ptsTots.ZQ.EP1,	UVSPF.ptsData.SS.EP1,	UVSPF.ptsTots.SS.EP1,	questTooltips.EP1},
			{18, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.EP2)),						UVSPF.ptsData.ZQ.EP2,	UVSPF.ptsTots.ZQ.EP2,	UVSPF.ptsData.SS.EP2,	UVSPF.ptsTots.SS.EP2,	questTooltips.EP2},
			{19, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.EP3)),						UVSPF.ptsData.ZQ.EP3,	UVSPF.ptsTots.ZQ.EP3,	UVSPF.ptsData.SS.EP3,	UVSPF.ptsTots.SS.EP3,	questTooltips.EP3},
			{20, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.EP4)),						UVSPF.ptsData.ZQ.EP4,	UVSPF.ptsTots.ZQ.EP4,	UVSPF.ptsData.SS.EP4,	UVSPF.ptsTots.SS.EP4,	questTooltips.EP4},
			{21, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.EP5)),						UVSPF.ptsData.ZQ.EP5,	UVSPF.ptsTots.ZQ.EP5,	UVSPF.ptsData.SS.EP5,	UVSPF.ptsTots.SS.EP5,	questTooltips.EP5},
			{22, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.CH)),						UVSPF.ptsData.ZQ.CH,		UVSPF.ptsTots.ZQ.CH,		UVSPF.ptsData.SS.CH,		UVSPF.ptsTots.SS.CH,		questTooltips.CH},
			{23, zf("<<C:1>> <<2>>",	GZNBId(UVSPF.data.ZId.ZN.CAD), "AD"),				UVSPF.ptsData.ZQ.CAD,	UVSPF.ptsTots.ZQ.CAD,	UVSPF.ptsData.SS.CAD,	UVSPF.ptsTots.SS.CAD,	questTooltips.CAD},
			{24, zf("<<C:1>> <<2>>",	GZNBId(UVSPF.data.ZId.ZN.CDC), "DC"),				UVSPF.ptsData.ZQ.CDC,	UVSPF.ptsTots.ZQ.CDC,	UVSPF.ptsData.SS.CDC,	UVSPF.ptsTots.SS.CDC,	questTooltips.CDC},
			{25, zf("<<C:1>> <<2>>",	GZNBId(UVSPF.data.ZId.ZN.CEP), "EP"),				UVSPF.ptsData.ZQ.CEP,	UVSPF.ptsTots.ZQ.CEP,	UVSPF.ptsData.SS.CEP,	UVSPF.ptsTots.SS.CEP,	questTooltips.CEP},
			{26, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.CMT)),						UVSPF.ptsData.ZQ.CMT,	UVSPF.ptsTots.ZQ.CMT,	UVSPF.ptsData.SS.CMT,	UVSPF.ptsTots.SS.CMT,	questTooltips.CMT},
			{27, zf("<<C:1>> <<C:2>>",	GS(UVSPF_GUI_ZN_LCL), GZNBId(UVSPF.data.ZId.ZN.CL)),	UVSPF.ptsData.ZQ.LCL,	UVSPF.ptsTots.ZQ.LCL,	UVSPF.ptsData.SS.LCL,	UVSPF.ptsTots.SS.LCL,	questTooltips.LCL},
			{28, zf("<<C:1>> <<C:2>>",	GS(UVSPF_GUI_ZN_UCL), GZNBId(UVSPF.data.ZId.ZN.CL)),	UVSPF.ptsData.ZQ.UCL,	UVSPF.ptsTots.ZQ.UCL,	UVSPF.ptsData.SS.UCL,	UVSPF.ptsTots.SS.UCL,	questTooltips.UCL},
			{29, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.IC)),						UVSPF.ptsData.ZQ.IC,		UVSPF.ptsTots.ZQ.IC,		UVSPF.ptsData.SS.IC,		UVSPF.ptsTots.SS.IC,		questTooltips.IC},
			{30, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.RO)),						UVSPF.ptsData.ZQ.RO,		UVSPF.ptsTots.ZQ.RO,		UVSPF.ptsData.SS.WR,		UVSPF.ptsTots.SS.WR,		questTooltips.RO},
			{31, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.HB)),						UVSPF.ptsData.ZQ.TG,		UVSPF.ptsTots.ZQ.TG,		UVSPF.ptsData.SS.HB,		UVSPF.ptsTots.SS.HB,		questTooltips.TG},
			{32, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.GC)),						UVSPF.ptsData.ZQ.DB,		UVSPF.ptsTots.ZQ.DB,		UVSPF.ptsData.SS.GC,		UVSPF.ptsTots.SS.GC,		questTooltips.DB},
			{33, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.VV)),						UVSPF.ptsData.ZQ.MW,		UVSPF.ptsTots.ZQ.MW,		UVSPF.ptsData.SS.VV,		UVSPF.ptsTots.SS.VV,		questTooltips.MW},
			{34, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.CC)),						UVSPF.ptsData.ZQ.CC,		UVSPF.ptsTots.ZQ.CC,		UVSPF.ptsData.SS.CC,		UVSPF.ptsTots.SS.CC,		questTooltips.CC},
			{35, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.SU)),						UVSPF.ptsData.ZQ.SU,		UVSPF.ptsTots.ZQ.SU,		UVSPF.ptsData.SS.SU,		UVSPF.ptsTots.SS.SU,		questTooltips.SU},
			{36, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.MM)),						UVSPF.ptsData.ZQ.MM,		UVSPF.ptsTots.ZQ.MM,		UVSPF.ptsData.SS.MM,		UVSPF.ptsTots.SS.MM,		questTooltips.MM},
			{37, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.NE)),						UVSPF.ptsData.ZQ.NE,		UVSPF.ptsTots.ZQ.NE,		UVSPF.ptsData.SS.NE,		UVSPF.ptsTots.SS.NE,		questTooltips.NE},
			{38, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.SE)),						UVSPF.ptsData.ZQ.SE,		UVSPF.ptsTots.ZQ.SE,		UVSPF.ptsData.SS.SE,		UVSPF.ptsTots.SS.SE,		questTooltips.SE},
      		{39, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.WS)),						UVSPF.ptsData.ZQ.WS,		UVSPF.ptsTots.ZQ.WS,		UVSPF.ptsData.SS.WS,		UVSPF.ptsTots.SS.WS,		questTooltips.WS},
      		{40, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.TR)),						UVSPF.ptsData.ZQ.TR,		UVSPF.ptsTots.ZQ.TR,		UVSPF.ptsData.SS.TR,		UVSPF.ptsTots.SS.TR,		questTooltips.TR},
      		{41, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.BW)),						UVSPF.ptsData.ZQ.BW,		UVSPF.ptsTots.ZQ.BW,		UVSPF.ptsData.SS.BW,		UVSPF.ptsTots.SS.BW,		questTooltips.BW},
		},
		SQS_SL_T = strF("%d/%d", UVSPF.ptsData.ZQTot, UVSPF.ptsTots.ZQTot),
		SQS_SS_T = strF("%d/%d", UVSPF.ptsData.SSTot, UVSPF.ptsTots.SSTot),
		GDQ = {
			{ 1, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD1)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.BC1)),	UVSPF.ptsData.GD.BC1,	UVSPF.ptsTots.GD.BC1,	GetGDQuestTooltipText("BC1")},
			{ 2, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD1)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.BC2)),	UVSPF.ptsData.GD.BC2,	UVSPF.ptsTots.GD.BC2,	GetGDQuestTooltipText("BC2")},
			{ 3, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.EH1)),	UVSPF.ptsData.GD.EH1,	UVSPF.ptsTots.GD.EH1,	GetGDQuestTooltipText("EH1")},
			{ 4, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.EH2)),	UVSPF.ptsData.GD.EH2,	UVSPF.ptsTots.GD.EH2,	GetGDQuestTooltipText("EH2")},
			{ 5, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.CA1)),	UVSPF.ptsData.GD.CA1,	UVSPF.ptsTots.GD.CA1,	GetGDQuestTooltipText("CA1")},
			{ 6, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.CA2)),	UVSPF.ptsData.GD.CA2,	UVSPF.ptsTots.GD.CA2,	GetGDQuestTooltipText("CA2")},
			{ 7, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD4)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.TI)),	UVSPF.ptsData.GD.TI,		UVSPF.ptsTots.GD.TI,		GetGDQuestTooltipText("TI")},
			{ 8, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD5)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.SW)),	UVSPF.ptsData.GD.SW,		UVSPF.ptsTots.GD.SW,		GetGDQuestTooltipText("SW")},
			{ 9, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC1)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.SC1)),	UVSPF.ptsData.GD.SC1,	UVSPF.ptsTots.GD.SC1,	GetGDQuestTooltipText("SC1")},
			{10, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC1)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.SC2)),	UVSPF.ptsData.GD.SC2,	UVSPF.ptsTots.GD.SC2,	GetGDQuestTooltipText("SC2")},
			{11, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.WS1)),	UVSPF.ptsData.GD.WS1,	UVSPF.ptsTots.GD.WS1,	GetGDQuestTooltipText("WS1")},
			{12, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.WS2)),	UVSPF.ptsData.GD.WS2,	UVSPF.ptsTots.GD.WS2,	GetGDQuestTooltipText("WS2")},
			{13, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.CH1)),	UVSPF.ptsData.GD.CH1,	UVSPF.ptsTots.GD.CH1,	GetGDQuestTooltipText("CH1")},
			{14, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.CH2)),	UVSPF.ptsData.GD.CH2,	UVSPF.ptsTots.GD.CH2,	GetGDQuestTooltipText("CH2")},
			{15, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC4)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.VF)),	UVSPF.ptsData.GD.VF,		UVSPF.ptsTots.GD.VF,		GetGDQuestTooltipText("VF")},
			{16, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC5)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.BH)),	UVSPF.ptsData.GD.BH,		UVSPF.ptsTots.GD.BH,		GetGDQuestTooltipText("BH")},
			{17, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP1)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.FG1)),	UVSPF.ptsData.GD.FG1,	UVSPF.ptsTots.GD.FG1,	GetGDQuestTooltipText("FG1")},
			{18, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP1)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.FG2)),	UVSPF.ptsData.GD.FG2,	UVSPF.ptsTots.GD.FG2,	GetGDQuestTooltipText("FG2")},
			{19, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.DC1)),	UVSPF.ptsData.GD.DC1,	UVSPF.ptsTots.GD.DC1,	GetGDQuestTooltipText("DC1")},
			{20, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.DC2)),	UVSPF.ptsData.GD.DC2,	UVSPF.ptsTots.GD.DC2,	GetGDQuestTooltipText("DC2")},
			{21, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.AC)),	UVSPF.ptsData.GD.AC,		UVSPF.ptsTots.GD.AC,		GetGDQuestTooltipText("AC")},
			{22, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP4)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.DK)),	UVSPF.ptsData.GD.DK,		UVSPF.ptsTots.GD.DK,		GetGDQuestTooltipText("DK")},
			{23, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP5)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.BC)),	UVSPF.ptsData.GD.BC,		UVSPF.ptsTots.GD.BC,		GetGDQuestTooltipText("BC")},
			{24, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.CH)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.VM)),	UVSPF.ptsData.GD.VM,		UVSPF.ptsTots.GD.VM,		GetGDQuestTooltipText("VM")},
			{25, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.CYD)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.ICP)),	UVSPF.ptsData.GD.ICP,	UVSPF.ptsTots.GD.ICP,	GetGDQuestTooltipText("ICP")},
			{26, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.CYD)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.WGT)),	UVSPF.ptsData.GD.WGT,	UVSPF.ptsTots.GD.WGT,	GetGDQuestTooltipText("WGT")},
			{27, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.CS)),	UVSPF.ptsData.GD.CS,		UVSPF.ptsTots.GD.CS,		GetGDQuestTooltipText("CS")},
			{28, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.RM)),	UVSPF.ptsData.GD.RM,		UVSPF.ptsTots.GD.RM,		GetGDQuestTooltipText("RM")},
			{29, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.CL)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.BF)),	UVSPF.ptsData.GD.BF,		UVSPF.ptsTots.GD.BF,		GetGDQuestTooltipText("BF")},
			{30, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.CL)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.FH)),	UVSPF.ptsData.GD.FH,		UVSPF.ptsTots.GD.FH,		GetGDQuestTooltipText("FH")},
			{31, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC5)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.FL)),	UVSPF.ptsData.GD.FL,		UVSPF.ptsTots.GD.FL,		GetGDQuestTooltipText("FL")},
			{32, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.SP)),	UVSPF.ptsData.GD.SP,		UVSPF.ptsTots.GD.SP,		GetGDQuestTooltipText("SP")},
			{33, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD5)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.MHK)),	UVSPF.ptsData.GD.MHK,	UVSPF.ptsTots.GD.MHK,	GetGDQuestTooltipText("MHK")},
			{34, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.MOS)),	UVSPF.ptsData.GD.MOS,	UVSPF.ptsTots.GD.MOS,	GetGDQuestTooltipText("MOS")},
			{35, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.GC)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.DoM)),	UVSPF.ptsData.GD.DoM,	UVSPF.ptsTots.GD.DoM,	GetGDQuestTooltipText("DoM")},
			{36, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP4)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.FV)),	UVSPF.ptsData.GD.FV,		UVSPF.ptsTots.GD.FV,		GetGDQuestTooltipText("FV")},
			{37, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.LM)),	UVSPF.ptsData.GD.LM,		UVSPF.ptsTots.GD.LM,		GetGDQuestTooltipText("LM")},
			{38, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.NE)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.MF)),	UVSPF.ptsData.GD.MF,		UVSPF.ptsTots.GD.MF,		GetGDQuestTooltipText("MF")},
			{39, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.RO)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.IR)),	UVSPF.ptsData.GD.IR,		UVSPF.ptsTots.GD.IR,		GetGDQuestTooltipText("IR")},
			{40, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC5)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.UG)),	UVSPF.ptsData.GD.UG,		UVSPF.ptsTots.GD.UG,		GetGDQuestTooltipText("UG")},
			{41, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.BGC)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.SG)),	UVSPF.ptsData.GD.SG,		UVSPF.ptsTots.GD.SG,		GetGDQuestTooltipText("SG")},
			{42, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.WS)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.CT)),	UVSPF.ptsData.GD.CT,		UVSPF.ptsTots.GD.CT,		GetGDQuestTooltipText("CT")},
			{43, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.CD)),	UVSPF.ptsData.GD.CD,		UVSPF.ptsTots.GD.CD,		GetGDQuestTooltipText("CD")},
			{44, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.GC)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.BDV)),	UVSPF.ptsData.GD.BDV,	UVSPF.ptsTots.GD.BDV,	GetGDQuestTooltipText("BDV")},
		},
		GDQ_T = strF("%s: %d/%d", GS(UVSPF_GUI_TOTAL), UVSPF.ptsData.GDTot, UVSPF.ptsTots.GDTot),
		PDGBE = {
			{ 1, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD1)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.AD1)),	UVSPF.ptsData.PD.AD1,	UVSPF.ptsTots.PD.AD1,	GetAchLink(UVSPF.data.PD.AD1[2])},
			{ 2, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.AD2)),	UVSPF.ptsData.PD.AD2,	UVSPF.ptsTots.PD.AD2,	GetAchLink(UVSPF.data.PD.AD2[2])},
			{ 3, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.AD3)),	UVSPF.ptsData.PD.AD3,	UVSPF.ptsTots.PD.AD3,	GetAchLink(UVSPF.data.PD.AD3[2])},
			{ 4, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD4)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.AD4)),	UVSPF.ptsData.PD.AD4,	UVSPF.ptsTots.PD.AD4,	GetAchLink(UVSPF.data.PD.AD4[2])},
			{ 5, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD5)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.AD5)),	UVSPF.ptsData.PD.AD5,	UVSPF.ptsTots.PD.AD5,	GetAchLink(UVSPF.data.PD.AD5[2])},
			{ 6, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC1)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.DC1)),	UVSPF.ptsData.PD.DC1,	UVSPF.ptsTots.PD.DC1,	GetAchLink(UVSPF.data.PD.DC1[2])},
			{ 7, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.DC2)),	UVSPF.ptsData.PD.DC2,	UVSPF.ptsTots.PD.DC2,	GetAchLink(UVSPF.data.PD.DC2[2])},
			{ 8, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.DC3)),	UVSPF.ptsData.PD.DC3,	UVSPF.ptsTots.PD.DC3,	GetAchLink(UVSPF.data.PD.DC3[2])},
			{ 9, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC4)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.DC4)),	UVSPF.ptsData.PD.DC4,	UVSPF.ptsTots.PD.DC4,	GetAchLink(UVSPF.data.PD.DC4[2])},
			{10, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC5)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.DC5)),	UVSPF.ptsData.PD.DC5,	UVSPF.ptsTots.PD.DC5,	GetAchLink(UVSPF.data.PD.DC5[2])},
			{11, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP1)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.EP1)),	UVSPF.ptsData.PD.EP1,	UVSPF.ptsTots.PD.EP1,	GetAchLink(UVSPF.data.PD.EP1[2])},
			{12, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.EP2)),	UVSPF.ptsData.PD.EP2,	UVSPF.ptsTots.PD.EP2,	GetAchLink(UVSPF.data.PD.EP2[2])},
			{13, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.EP3)),	UVSPF.ptsData.PD.EP3,	UVSPF.ptsTots.PD.EP3,	GetAchLink(UVSPF.data.PD.EP3[2])},
			{14, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP4)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.EP4)),	UVSPF.ptsData.PD.EP4,	UVSPF.ptsTots.PD.EP4,	GetAchLink(UVSPF.data.PD.EP4[2])},
			{15, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP5)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.EP5)),	UVSPF.ptsData.PD.EP5,	UVSPF.ptsTots.PD.EP5,	GetAchLink(UVSPF.data.PD.EP5[2])},
			{16, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.CH)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.CH)),	UVSPF.ptsData.PD.CH,		UVSPF.ptsTots.PD.CH,		GetAchLink(UVSPF.data.PD.CH[2])},
			{17, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.RO)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.WOO)),	UVSPF.ptsData.PD.WOO,	UVSPF.ptsTots.PD.WOO,	GetAchLink(UVSPF.data.PD.WOO[2])},
			{18, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.RO)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.WRK)),	UVSPF.ptsData.PD.WRK,	UVSPF.ptsTots.PD.WRK,	GetAchLink(UVSPF.data.PD.WRK[2])},
			{19, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.VV)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.VFW)),	UVSPF.ptsData.PD.VFW,	UVSPF.ptsTots.PD.VFW,	GetAchLink(UVSPF.data.PD.VFW[2])},
			{20, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.VV)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.VNC)),	UVSPF.ptsData.PD.VNC,	UVSPF.ptsTots.PD.VNC,	GetAchLink(UVSPF.data.PD.VNC[2])},
			{21, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.SU)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.SKW)),	UVSPF.ptsData.PD.SKW,	UVSPF.ptsTots.PD.SKW,	GetAchLink(UVSPF.data.PD.SKW[2])},
			{22, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.SU)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.SSH)),	UVSPF.ptsData.PD.SSH,	UVSPF.ptsTots.PD.SSH,	GetAchLink(UVSPF.data.PD.SSH[2])},
			{23, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.NE)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.OC)),	UVSPF.ptsData.PD.OC,		UVSPF.ptsTots.PD.OC,		GetAchLink(UVSPF.data.PD.OC[2])},
			{24, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.NE)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.RN)),	UVSPF.ptsData.PD.RN,		UVSPF.ptsTots.PD.RN,		GetAchLink(UVSPF.data.PD.RN[2])},
			{25, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.WS)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.LT)),	UVSPF.ptsData.PD.LT,		UVSPF.ptsTots.PD.LT,		GetAchLink(UVSPF.data.PD.LT[2])},
			{26, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.BGC)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.NK)),	UVSPF.ptsData.PD.NK,		UVSPF.ptsTots.PD.NK,		GetAchLink(UVSPF.data.PD.NK[2])},
			{27, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.BW)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.ZA)),	UVSPF.ptsData.PD.ZA,		UVSPF.ptsTots.PD.ZA,		GetAchLink(UVSPF.data.PD.ZA[2])},
			{28, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.BW)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.TSH)),	UVSPF.ptsData.PD.TSH,		UVSPF.ptsTots.PD.TSH,		GetAchLink(UVSPF.data.PD.TSH[2])},
		},
		PDGBE_T = strF("%s: %d/%d", GS(UVSPF_GUI_TOTAL), UVSPF.ptsData.PDTot, UVSPF.ptsTots.PDTot),
		CharacterTot = strF("%s: %d/%d", GS(UVSPF_GUI_CHAR_TOTAL), UVSPF.ptsData.Tot, UVSPF.ptsTots.Tot),
	}
end

local function UVSPF_CheckSavedVars(value)
	local charId = GCCId()
	if(selectedChar ~= charId) then return false end
	if(value == nil) then
		--Write the character settings table.
		UVSPF.sVar.settings[charId] = {}
		UVSPF.sVar.settings[charId] = UVSPF_LTF:CopyTable(UVSPF.settings)
		
		--Write the character points data table.
		UVSPF.sVar.ptsData[charId] = {}
		UVSPF.sVar.ptsData[charId] = UVSPF_LTF:CopyTable(UVSPF.ptsData)
	end
	return true
end

local function UVSPF_SetLevelPoints()
	UVSPF.ptsData.Level = math.floor(GetUnitLevel("player")/5) + math.floor(GetUnitLevel("player")/10) + (GetUnitLevel("player") - 1)
	
	--Update saved variables.
	if(UVSPF_CheckSavedVars(UVSPF.sVar.ptsData[selectedChar])) then
		UVSPF.sVar.ptsData[selectedChar].Level = UVSPF.ptsData.Level
	end
end

local function UVSPF_SetQuestPoints()
	--Main Quest Skill Points
	for i=1, #UVSPF.data.MQ do
		UVSPF.ptsData.MainQ = UVSPF.ptsData.MainQ + (IAchC(UVSPF.data.MQ[i][2]) and UVSPF.data.MQ[i][4] or 0)
	end
	
	--Morrowind Only Character Quest Skill Points
	UVSPF.ptsData.MWChar = ((GCQI(UVSPF.data.MO[1][1]) ~= "" or UVSPF.settings.MWC) and UVSPF.data.MO[1][4] or 0)
	
	--Summerset Only Character Quest Skill Points
	UVSPF.ptsData.SUChar = ((GCQI(UVSPF.data.SO[1][1]) ~= "" or UVSPF.settings.SSC) and UVSPF.data.SO[1][4] or 0)
	
	--Elsweyr Only Character Quest Skill Points
	UVSPF.ptsData.EWChar = ((GCQI(UVSPF.data.EO[1][1]) ~= "" or UVSPF.settings.EWC) and UVSPF.data.EO[1][4] or 0)
  
  	--Greymoor Only Character Quest Skill Points
	UVSPF.ptsData.GMChar = ((GCQI(UVSPF.data.GO[1][1]) ~= "" or UVSPF.settings.GWC) and UVSPF.data.GO[1][4] or 0)
  
	--Blackwoood Only Character Quest Skill Points
  	UVSPF.ptsData.BWChar = ((GCQI(UVSPF.data.BO[1][1]) ~= "" or UVSPF.settings.BWC) and UVSPF.data.BO[1][4] or 0)
	
	for k,_ in pairs(UVSPF.ptsData.ZQ) do
		if(UVSPF.data[k] ~= nil) then
			for i=1, #UVSPF.data[k] do
				UVSPF.ptsData.ZQ[k] = UVSPF.ptsData.ZQ[k] + ((UVSPF.data[k][i][2] == 0 and (GCQI(UVSPF.data[k][i][1]) ~= "") or IAchC(UVSPF.data[k][i][2])) and UVSPF.data[k][i][4] or 0)
			end
			UVSPF.ptsData.ZQTot = UVSPF.ptsData.ZQTot + UVSPF.ptsData.ZQ[k]
		end
	end
	
	--Group Dungeon Quest Skill Points
	for k,_ in pairs(UVSPF.ptsData.GD) do
		UVSPF.ptsData.GD[k] = (GCQI(UVSPF.data.GD[k][2]) ~= "" and 1 or 0)
		UVSPF.ptsData.GDTot = UVSPF.ptsData.GDTot + UVSPF.ptsData.GD[k]
	end
	
	--Update saved variables for all.
	if(UVSPF_CheckSavedVars(UVSPF.sVar.ptsData[selectedChar])) then
		UVSPF.sVar.ptsData[selectedChar].MainQ = UVSPF.ptsData.MainQ
		UVSPF.sVar.ptsData[selectedChar].MWChar = UVSPF.ptsData.MWChar
		UVSPF.sVar.ptsData[selectedChar].SUChar = UVSPF.ptsData.SUChar
		UVSPF.sVar.ptsData[selectedChar].EWChar = UVSPF.ptsData.EWChar
		UVSPF.sVar.ptsData[selectedChar].GMChar = UVSPF.ptsData.GMChar
		UVSPF.sVar.ptsData[selectedChar].BWChar = UVSPF.ptsData.BWChar		

		UVSPF.sVar.ptsData[selectedChar].ZQ = UVSPF_LTF:CopyTable(UVSPF.ptsData.ZQ)
		UVSPF.sVar.ptsData[selectedChar].GD = UVSPF_LTF:CopyTable(UVSPF.ptsData.GD)
		
		UVSPF.sVar.ptsData[selectedChar].ZQTot = UVSPF.ptsData.ZQTot
		UVSPF.sVar.ptsData[selectedChar].GDTot = UVSPF.ptsData.GDTot
	end
end

local function UVSPF_SetPublicDungeonPoints()
	for k,_ in pairs(UVSPF.ptsData.PD) do
		UVSPF.ptsData.PD[k] = (IAchC(UVSPF.data.PD[k][2]) and 1 or 0)
		UVSPF.ptsData.PDTot = UVSPF.ptsData.PDTot + UVSPF.ptsData.PD[k]
	end
	
	if(UVSPF_CheckSavedVars(UVSPF.sVar.ptsData[selectedChar])) then
		--Update saved variables.
		UVSPF.sVar.ptsData[selectedChar].PD		= UVSPF_LTF:CopyTable(UVSPF.ptsData.PD)
		UVSPF.sVar.ptsData[selectedChar].PDTot	= UVSPF.ptsData.PDTot
	end
end

local function UVSPF_SetSkyshardPoints()
	for k,_ in pairs(UVSPF.ptsData.SS) do
		if(IAchC(UVSPF.data.SS[k][2])) then UVSPF.ptsData.SS[k] = GAchNCr(UVSPF.data.SS[k][2])
		else
			for i = 1, GAchNCr(UVSPF.data.SS[k][2]) do
				local _, numCompleted = GAchCr(UVSPF.data.SS[k][2], i)
				if(numCompleted > 0) then UVSPF.ptsData.SS[k] = UVSPF.ptsData.SS[k] + 1 end
			end
		end
		UVSPF.ptsData.numSSTot = UVSPF.ptsData.numSSTot + UVSPF.ptsData.SS[k]
	end
	
	--Calculate the total and round for points.
	UVSPF.ptsData.SSTot = math.floor(UVSPF.ptsData.numSSTot/3)
	
	if(UVSPF_CheckSavedVars(UVSPF.sVar.ptsData[selectedChar])) then
		--Update saved variables for all.
		UVSPF.sVar.ptsData[selectedChar].SS			= UVSPF_LTF:CopyTable(UVSPF.ptsData.SS)
		UVSPF.sVar.ptsData[selectedChar].numSSTot	= UVSPF.ptsData.numSSTot
		UVSPF.sVar.ptsData[selectedChar].SSTot		= UVSPF.ptsData.SSTot
	end
end

--Temporary fix for ZOS' 4.3.7 bug.
--EsoUI/Ingame/Skills/SkillsDataManager.lua:1202: attempt to index a nil value
function UVSPF_GetCraftingSkillLineIndices(tradeskillType)
	local skillLineData = SKILLS_DATA_MANAGER:GetCraftingSkillLineData(tradeskillType)
	if skillLineData then
		return skillLineData:GetIndices()
	end
	return 0, 0, 0
end

local enchantingSkillType, enchantingSkillLine = UVSPF_GetCraftingSkillLineIndices(CRAFTING_TYPE_ENCHANTING)
local provisionSkillType, provisionSkillLine = UVSPF_GetCraftingSkillLineIndices(CRAFTING_TYPE_PROVISIONING)
local DARK_BROTHERHOOD, FIGHTERS_GUILD, MAGES_GUILD, THIEVES_GUILD, UNDAUNTED, SOUL_MAGIC, LEGERDEMAIN, PSIJIC_ORDER = 118, 45, 44, 117, 55, 72, 111, 130
local VAMPIRE, SCRYING, EXCAVATION = 51, 155, 157

local function UVSPF_IsValidRacialLine(skillType, skillLine)
	if (skillType == SKILL_TYPE_RACIAL) then
		local _, _, _, skillLineId = GetSkillLineInfo(skillType, skillLine)
		return skillLineId == UVSPF.data.racialLineIds[GetUnitRaceId("player")]
	end
	return false
end

local function UVSPF_GetReduceAbility(skillType, skillLine, skillIndex)
	local val = 0
	if skillType == SKILL_TYPE_WORLD then
		local name, _, _, skillLineId = GetSkillLineInfo(skillType, skillLine)
		val = ((skillLineId == SOUL_MAGIC and skillIndex == 2) and 1 or val) -- Soul Magic - Soul Trap
		val = ((skillLineId == SCRYING and skillIndex == 1) and 1 or val) -- Scrying - Scry
		val = ((skillLineId == SCRYING and skillIndex == 2) and 1 or val) -- Scrying - Antiquarian Insight
		val = ((skillLineId == EXCAVATION and skillIndex == 1) and 1 or val) -- Excavation - Hand Brush
		val = ((skillLineId == EXCAVATION and skillIndex == 2) and 1 or val) -- Excavation - Augur
		val = ((skillLineId == VAMPIRE and skillIndex == 7) and 1 or val) -- Vampire - Feed
		val = ((IsWerewolfSkillLine(skillType, skillLine) and skillIndex == 1) and 1 or val) -- Werewolf - Transformation
		val = ((IsWerewolfSkillLine(skillType, skillLine) and skillIndex == 7) and 1 or val) -- Werewolf - Devour
	end
	if skillType == SKILL_TYPE_TRADESKILL then
		val = (skillIndex == 1 and 1 or val)
		val = ((skillIndex == 2 and skillType == enchantingSkillType and skillLine == enchantingSkillLine) and 1 or val)
		val = ((skillIndex == 2 and skillType == provisionSkillType and skillLine == provisionSkillLine) and 1 or val)
	end
	
	val = ((UVSPF_IsValidRacialLine(skillType, skillLine) and skillIndex == 1) and 1 or val)
	
	if skillType == SKILL_TYPE_GUILD then
		local name, _, _, skillLineId = GetSkillLineInfo(skillType, skillLine)
		val = (skillLineId == DARK_BROTHERHOOD and (skillIndex == 1 and 1 or val) or val)
		val = (skillLineId == THIEVES_GUILD and (skillIndex == 1 and 1 or val) or val)
		val = (skillLineId == PSIJIC_ORDER and (skillIndex == 7 and 1 or val) or val)
	end
	return val
end

local function UVSPF_GetSkillSpentPoints(skillType, skillLine, skillIndex)
	local skills = UVSPF.cache.skillTypes[skillType].lines[skillLine].skills
	local _, _, _, _, _, purchased, progressionIndex = GetSkillAbilityInfo(skillType, skillLine, skillIndex)
	local spent, possible, reduction
	
	if not purchased then spent = 0 end
	reduction = UVSPF_GetReduceAbility(skillType, skillLine, skillIndex)
	
	if progressionIndex then
		local _, morph = GetAbilityProgressionInfo(progressionIndex)
		if not spent then
			spent = (morph > 0 and (2 - reduction) or (1 - reduction))
		end
		possible = 2 - reduction
	else
		local currentLevel, maxLevel = GetSkillAbilityUpgradeInfo(skillType, skillLine, skillIndex)
		if currentLevel then
			if not spent then spent = currentLevel - reduction end
			possible = maxLevel - reduction
		else
			if not spent then spent = 1 - reduction end
			possible = 1 - reduction
		end
	end
	skills[skillIndex] = {spent, possible}
	return skills[skillIndex]
end

local function UVSPF_GetLineSpentPoints(skillType, skillLine)
	if(skillType ~= SKILL_TYPE_RACIAL or UVSPF_IsValidRacialLine(skillType, skillLine)) then
		UVSPF.cache.skillTypes[skillType].lines[skillLine] = {}
		local line = UVSPF.cache.skillTypes[skillType].lines[skillLine]
		line.skills = {}
		line.total = 0
		line.possible = 0
		local numSkillAbilities = GetNumSkillAbilities(skillType, skillLine)
		local spent
		for ability = 1, numSkillAbilities do
			spent = UVSPF_GetSkillSpentPoints(skillType, skillLine, ability)
			line.total = line.total + spent[1]
			line.possible = line.possible + spent[2]
		end
		
		return line.total
	end
	return 0
end

local function UVSPF_GetTypeSpentPoints(skillTypeId)
	UVSPF.cache.skillTypes[skillTypeId] = {}
	local skillType = UVSPF.cache.skillTypes[skillTypeId]
	skillType.lines = {}
	skillType.total = 0
	local numSkillLines = GetNumSkillLines(skillTypeId)
	for skillLine = 1, numSkillLines do skillType.total = skillType.total + UVSPF_GetLineSpentPoints(skillTypeId, skillLine) end
	return skillType.total
end

local function UVSPF_GetTotSkillPoints()
	UVSPF.cache.skillTypes = {}
	UVSPF.cache.total = GetAvailableSkillPoints()
	
	for skillType = 1, GetNumSkillTypes() do UVSPF.cache.total = UVSPF.cache.total + UVSPF_GetTypeSpentPoints(skillType) end
	return UVSPF.cache.total
end

local function UVSPF_SetFoliumDiscognitumPoints()
	if(UVSPF.settings.FD.override) then
		UVSPF.ptsData.FolDis = (UVSPF.settings.FD.charHasFD and 2 or 0)
	else
		local skillPoints = UVSPF_GetTotSkillPoints()
		local skillPointsDiff =	UVSPF.ptsData.Level + UVSPF.ptsData.MainQ + UVSPF.ptsData.MWChar +
								UVSPF.ptsData.SUChar + UVSPF.ptsData.EWChar + UVSPF.ptsData.GMChar + UVSPF.ptsData.BWChar 
								+ UVSPF.ptsData.PvPRank + UVSPF.ptsData.MaelAr + UVSPF.ptsData.VatAr + UVSPF.ptsData.ZQTot + 
								UVSPF.ptsData.SSTot + UVSPF.ptsData.GDTot + UVSPF.ptsData.PDTot
		UVSPF.ptsData.FolDis = (skillPoints == skillPointsDiff + 2 and 2 or 0)
	end
	
	--Update saved variables.
	if(UVSPF_CheckSavedVars(UVSPF.sVar.ptsData[selectedChar])) then
		UVSPF.sVar.ptsData[selectedChar].FolDis = UVSPF.ptsData.FolDis
	end
end

local function UVSPF_SetAllianceWarRankPoints()
	UVSPF.ptsData.PvPRank = (GetUnitAvARank("player") == nil and 0 or GetUnitAvARank("player"))
	
	--Update saved variables.
	if(UVSPF_CheckSavedVars(UVSPF.sVar.ptsData[selectedChar])) then
		UVSPF.sVar.ptsData[selectedChar].PvPRank = UVSPF.ptsData.PvPRank
	end
end

local function UVSPF_SetMaelArPoints()
	UVSPF.ptsData.MaelAr = (IAchC(UVSPF.data.MAAch) and 1 or 0)
	
	--Update saved variables.
	if(UVSPF_CheckSavedVars(UVSPF.sVar.ptsData[selectedChar])) then
		UVSPF.sVar.ptsData[selectedChar].MaelAr = UVSPF.ptsData.MaelAr
	end
end

local function UVSPF_SetVatArPoints()
	UVSPF.ptsData.VatAr = (IAchC(UVSPF.data.VAAch) and 1 or 0)
	
	--Update saved variables.
	if(UVSPF_CheckSavedVars(UVSPF.sVar.ptsData[selectedChar])) then
		UVSPF.sVar.ptsData[selectedChar].VatAr = UVSPF.ptsData.VatAr
	end
end

local function UVSPF_SetGeneralPoints()
	UVSPF.ptsData.GenTot =	UVSPF.ptsData.Level + UVSPF.ptsData.MainQ + UVSPF.ptsData.FolDis + UVSPF.ptsData.MWChar + 
							UVSPF.ptsData.SUChar + UVSPF.ptsData.EWChar + UVSPF.ptsData.GMChar + UVSPF.ptsData.BWChar + UVSPF.ptsData.PvPRank + UVSPF.ptsData.MaelAr + UVSPF.ptsData.VatAr
	
	--Update saved variables.
	if(UVSPF_CheckSavedVars(UVSPF.sVar.ptsData[selectedChar])) then
		UVSPF.sVar.ptsData[selectedChar].GenTot = UVSPF.ptsData.GenTot
	end
end

local function UVSPF_SetTotPoints()
	UVSPF.ptsData.Tot =	UVSPF.ptsData.GenTot + UVSPF.ptsData.ZQTot + UVSPF.ptsData.SSTot +
						UVSPF.ptsData.GDTot + UVSPF.ptsData.PDTot
	
	--Update saved variables.
	if(UVSPF_CheckSavedVars(UVSPF.sVar.ptsData[selectedChar])) then
		UVSPF.sVar.ptsData[selectedChar].Tot = UVSPF.ptsData.Tot
	end
end

local function GetSV(value)
	return  value ~= nil and value or 0
end

local function UVSPF_LoadData(charId)
	sVarPtsData = UVSPF.sVar.ptsData[charId]
	
	if(UVSPF.sVar.ptsData[charId] == nil) then
		--Write the character settings table.
		UVSPF.sVar.settings[charId] = {}
		UVSPF.sVar.settings[charId] = UVSPF_LTF:CopyTable(UVSPF.settings)
		
		--Write the character points data table.
		UVSPF.sVar.ptsData[charId] = {}
		UVSPF.sVar.ptsData[charId] = UVSPF_LTF:CopyTable(UVSPF.ptsData)
	end
	
	questTooltips = {
		WP	 = GS(UVSPF_QUEST_NONE),
		AD0	 = GS(UVSPF_QUEST_NONE),
		AD1  = GetQuestTooltipText("AD1"),
		AD2  = GetQuestTooltipText("AD2"),
		AD3  = GetQuestTooltipText("AD3"),
		AD4  = GetQuestTooltipText("AD4"),
		AD5  = GetQuestTooltipText("AD5"),
		CC   = GetQuestTooltipText("CC"),
		CH   = GetQuestTooltipText("CH"),
		CAD	 = GS(UVSPF_QUEST_NONE),
		CDC	 = GS(UVSPF_QUEST_NONE),
		CEP	 = GS(UVSPF_QUEST_NONE),
		CMT	 = GS(UVSPF_QUEST_NONE),
		DB   = GetQuestTooltipText("DB"),
		DC0a = GS(UVSPF_QUEST_NONE),
		DC0b = GS(UVSPF_QUEST_NONE),
		DC1	 = GetQuestTooltipText("DC1"),
		DC2	 = GetQuestTooltipText("DC2"),
		DC3	 = GetQuestTooltipText("DC3"),
		DC4	 = GetQuestTooltipText("DC4"),
		DC5	 = GetQuestTooltipText("DC5"),
		EO	 = GetQuestTooltipText("EO"),
		EP0a = GS(UVSPF_QUEST_NONE),
		EP0b = GS(UVSPF_QUEST_NONE),
		EP1	 = GetQuestTooltipText("EP1"),
		EP2	 = GetQuestTooltipText("EP2"),
		EP3	 = GetQuestTooltipText("EP3"),
		EP4	 = GetQuestTooltipText("EP4"),
		EP5	 = GetQuestTooltipText("EP5"),
		IC	 = GetQuestTooltipText("IC"),
		LCL	 = GS(UVSPF_QUEST_NONE),
		UCL	 = GS(UVSPF_QUEST_NONE),
		MM	 = GetQuestTooltipText("MM"),
		MO	 = GetQuestTooltipText("MO"),
		MW	 = GetQuestTooltipText("MW"),
		MQ	 = GetQuestTooltipText("MQ"),
		NE	 = GetQuestTooltipText("NE"),
		RO	 = GetQuestTooltipText("RO"),
		SE	 = GetQuestTooltipText("SE"),
		SO	 = GetQuestTooltipText("SO"),
		TG	 = GetQuestTooltipText("TG"),
		SU	 = GetQuestTooltipText("SU"),
		WS   = GetQuestTooltipText("WS"),
		GO   = GetQuestTooltipText("GO"),
		TR   = GetQuestTooltipText("TR"),
		BW   = GetQuestTooltipText("BW"),
		BO   = GetQuestTooltipText("BO"),
	}
	
	UVSPF.GUI = {
		GSP = {
			{1,  GS(UVSPF_GUI_CHAR_LEVEL),	GetSV(sVarPtsData.Level),	UVSPF.ptsTots.Level,		GS(UVSPF_QUEST_NA)},
			{2,  GS(UVSPF_GUI_MAIN_QUEST),	GetSV(sVarPtsData.MainQ),	UVSPF.ptsTots.MainQ,		questTooltips.MQ},
			{3,  GS(UVSPF_GUI_FOLIUM),		GetSV(sVarPtsData.FolDis),	UVSPF.ptsTots.FolDis,	GS(UVSPF_QUEST_NA)},
			{4,  GS(UVSPF_GUI_MW_CHAR),		GetSV(sVarPtsData.MWChar),	UVSPF.ptsTots.MWChar,	questTooltips.MO},
			{5,  GS(UVSPF_GUI_SU_CHAR),		GetSV(sVarPtsData.SUChar),	UVSPF.ptsTots.SUChar,	questTooltips.SO},
			{6,  GS(UVSPF_GUI_EW_CHAR),		GetSV(sVarPtsData.EWChar),	UVSPF.ptsTots.EWChar,	questTooltips.EO},
			{7,  GS(UVSPF_GUI_GM_CHAR),		GetSV(sVarPtsData.GMChar),	UVSPF.ptsTots.GMChar,	questTooltips.GO},
			{8,  GS(UVSPF_GUI_BW_CHAR),		GetSV(sVarPtsData.BWChar),	UVSPF.ptsTots.BWChar,	questTooltips.BO},
			{9,  GS(UVSPF_GUI_AVA_RANK),	GetSV(sVarPtsData.PvPRank),	UVSPF.ptsTots.PvPRank,	GS(UVSPF_QUEST_NA)},
			{10, GS(UVSPF_GUI_MAEL_ARENA),	GetSV(sVarPtsData.MaelAr),	UVSPF.ptsTots.MaelAr,	GS(UVSPF_QUEST_NA)},
			{11, GS(UVSPF_GUI_VAT_ARENA),	GetSV(sVarPtsData.VatAr),	UVSPF.ptsTots.VatAr,	GS(UVSPF_QUEST_NA)},
		},
		GSP_T = strF("%s: %d/%d", GS(UVSPF_GUI_TOTAL), sVarPtsData.GenTot, UVSPF.ptsTots.GenTot),
		SQS = {
			{ 1, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.WP)),						GetSV(sVarPtsData.ZQ.WP),	UVSPF.ptsTots.ZQ.WP,		GetSV(sVarPtsData.SS.MQ),	UVSPF.ptsTots.SS.MQ,		questTooltips.WP},
			{ 2, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.AD0)),						GetSV(sVarPtsData.ZQ.AD0),	UVSPF.ptsTots.ZQ.AD0,	GetSV(sVarPtsData.SS.AD0),	UVSPF.ptsTots.SS.AD0,	questTooltips.AD0},
			{ 3, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.AD1)),						GetSV(sVarPtsData.ZQ.AD1),	UVSPF.ptsTots.ZQ.AD1,	GetSV(sVarPtsData.SS.AD1),	UVSPF.ptsTots.SS.AD1,	questTooltips.AD1},
			{ 4, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.AD2)),						GetSV(sVarPtsData.ZQ.AD2),	UVSPF.ptsTots.ZQ.AD2,	GetSV(sVarPtsData.SS.AD2),	UVSPF.ptsTots.SS.AD2,	questTooltips.AD2},
			{ 5, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.AD3)),						GetSV(sVarPtsData.ZQ.AD3),	UVSPF.ptsTots.ZQ.AD3,	GetSV(sVarPtsData.SS.AD3),	UVSPF.ptsTots.SS.AD3,	questTooltips.AD3},
			{ 6, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.AD4)),						GetSV(sVarPtsData.ZQ.AD4),	UVSPF.ptsTots.ZQ.AD4,	GetSV(sVarPtsData.SS.AD4),	UVSPF.ptsTots.SS.AD4,	questTooltips.AD4},
			{ 7, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.AD5)),						GetSV(sVarPtsData.ZQ.AD5),	UVSPF.ptsTots.ZQ.AD5,	GetSV(sVarPtsData.SS.AD5),	UVSPF.ptsTots.SS.AD5,	questTooltips.AD5},
			{ 8, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.DC0B)),						GetSV(sVarPtsData.ZQ.DC0b),	UVSPF.ptsTots.ZQ.DC0b,	GetSV(sVarPtsData.SS.DC0b),	UVSPF.ptsTots.SS.DC0b,	questTooltips.DC0b},
			{ 9, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.DC0A)),						GetSV(sVarPtsData.ZQ.DC0a),	UVSPF.ptsTots.ZQ.DC0a,	GetSV(sVarPtsData.SS.DC0a),	UVSPF.ptsTots.SS.DC0a,	questTooltips.DC0a},
			{10, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.DC1)),						GetSV(sVarPtsData.ZQ.DC1),	UVSPF.ptsTots.ZQ.DC1,	GetSV(sVarPtsData.SS.DC1),	UVSPF.ptsTots.SS.DC1,	questTooltips.DC1},
			{11, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.DC2)),						GetSV(sVarPtsData.ZQ.DC2),	UVSPF.ptsTots.ZQ.DC2,	GetSV(sVarPtsData.SS.DC2),	UVSPF.ptsTots.SS.DC2,	questTooltips.DC2},
			{12, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.DC3)),						GetSV(sVarPtsData.ZQ.DC3),	UVSPF.ptsTots.ZQ.DC3,	GetSV(sVarPtsData.SS.DC3),	UVSPF.ptsTots.SS.DC3,	questTooltips.DC3},
			{13, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.DC4)),						GetSV(sVarPtsData.ZQ.DC4),	UVSPF.ptsTots.ZQ.DC4,	GetSV(sVarPtsData.SS.DC4),	UVSPF.ptsTots.SS.DC4,	questTooltips.DC4},
			{14, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.DC5)),						GetSV(sVarPtsData.ZQ.DC5),	UVSPF.ptsTots.ZQ.DC5,	GetSV(sVarPtsData.SS.DC5),	UVSPF.ptsTots.SS.DC5,	questTooltips.DC5},
			{15, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.EP0B)),						GetSV(sVarPtsData.ZQ.EP0b),	UVSPF.ptsTots.ZQ.EP0b,	GetSV(sVarPtsData.SS.EP0b),	UVSPF.ptsTots.SS.EP0b,	questTooltips.EP0b},
			{16, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.EP0A)),						GetSV(sVarPtsData.ZQ.EP0a),	UVSPF.ptsTots.ZQ.EP0a,	GetSV(sVarPtsData.SS.EP0a),	UVSPF.ptsTots.SS.EP0a,	questTooltips.EP0a},
			{17, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.EP1)),						GetSV(sVarPtsData.ZQ.EP1),	UVSPF.ptsTots.ZQ.EP1,	GetSV(sVarPtsData.SS.EP1),	UVSPF.ptsTots.SS.EP1,	questTooltips.EP1},
			{18, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.EP2)),						GetSV(sVarPtsData.ZQ.EP2),	UVSPF.ptsTots.ZQ.EP2,	GetSV(sVarPtsData.SS.EP2),	UVSPF.ptsTots.SS.EP2,	questTooltips.EP2},
			{19, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.EP3)),						GetSV(sVarPtsData.ZQ.EP3),	UVSPF.ptsTots.ZQ.EP3,	GetSV(sVarPtsData.SS.EP3),	UVSPF.ptsTots.SS.EP3,	questTooltips.EP3},
			{20, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.EP4)),						GetSV(sVarPtsData.ZQ.EP4),	UVSPF.ptsTots.ZQ.EP4,	GetSV(sVarPtsData.SS.EP4),	UVSPF.ptsTots.SS.EP4,	questTooltips.EP4},
			{21, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.EP5)),						GetSV(sVarPtsData.ZQ.EP5),	UVSPF.ptsTots.ZQ.EP5,	GetSV(sVarPtsData.SS.EP5),	UVSPF.ptsTots.SS.EP5,	questTooltips.EP5},
			{22, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.CH)),						GetSV(sVarPtsData.ZQ.CH),	UVSPF.ptsTots.ZQ.CH,		GetSV(sVarPtsData.SS.CH),	UVSPF.ptsTots.SS.CH,		questTooltips.CH},
			{23, zf("<<C:1>> <<2>>",	GZNBId(UVSPF.data.ZId.ZN.CAD), "AD"),				GetSV(sVarPtsData.ZQ.CAD),	UVSPF.ptsTots.ZQ.CAD,	GetSV(sVarPtsData.SS.CAD),	UVSPF.ptsTots.SS.CAD,	questTooltips.CAD},
			{24, zf("<<C:1>> <<2>>",	GZNBId(UVSPF.data.ZId.ZN.CDC), "DC"),				GetSV(sVarPtsData.ZQ.CDC),	UVSPF.ptsTots.ZQ.CDC,	GetSV(sVarPtsData.SS.CDC),	UVSPF.ptsTots.SS.CDC,	questTooltips.CDC},
			{25, zf("<<C:1>> <<2>>",	GZNBId(UVSPF.data.ZId.ZN.CEP), "EP"),				GetSV(sVarPtsData.ZQ.CEP),	UVSPF.ptsTots.ZQ.CEP,	GetSV(sVarPtsData.SS.CEP),	UVSPF.ptsTots.SS.CEP,	questTooltips.CEP},
			{26, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.CMT)),						GetSV(sVarPtsData.ZQ.CMT),	UVSPF.ptsTots.ZQ.CMT,	GetSV(sVarPtsData.SS.CMT),	UVSPF.ptsTots.SS.CMT,	questTooltips.CMT},
			{27, zf("<<C:1>> <<C:2>>",	GS(UVSPF_GUI_ZN_LCL), GZNBId(UVSPF.data.ZId.ZN.CL)),	GetSV(sVarPtsData.ZQ.LCL),	UVSPF.ptsTots.ZQ.LCL,	GetSV(sVarPtsData.SS.LCL),	UVSPF.ptsTots.SS.LCL,	questTooltips.LCL},
			{28, zf("<<C:1>> <<C:2>>",	GS(UVSPF_GUI_ZN_UCL), GZNBId(UVSPF.data.ZId.ZN.CL)),	GetSV(sVarPtsData.ZQ.UCL),	UVSPF.ptsTots.ZQ.UCL,	GetSV(sVarPtsData.SS.UCL),	UVSPF.ptsTots.SS.UCL,	questTooltips.UCL},
			{29, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.IC)),						GetSV(sVarPtsData.ZQ.IC),	UVSPF.ptsTots.ZQ.IC,		GetSV(sVarPtsData.SS.IC),	UVSPF.ptsTots.SS.IC,		questTooltips.IC},
			{30, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.RO)),						GetSV(sVarPtsData.ZQ.RO),	UVSPF.ptsTots.ZQ.RO,		GetSV(sVarPtsData.SS.WR),	UVSPF.ptsTots.SS.WR,		questTooltips.RO},
			{31, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.HB)),						GetSV(sVarPtsData.ZQ.TG),	UVSPF.ptsTots.ZQ.TG,		GetSV(sVarPtsData.SS.HB),	UVSPF.ptsTots.SS.HB,		questTooltips.TG},
			{32, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.GC)),						GetSV(sVarPtsData.ZQ.DB),	UVSPF.ptsTots.ZQ.DB,		GetSV(sVarPtsData.SS.GC),	UVSPF.ptsTots.SS.GC,		questTooltips.DB},
			{33, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.VV)),						GetSV(sVarPtsData.ZQ.MW),	UVSPF.ptsTots.ZQ.MW,		GetSV(sVarPtsData.SS.VV),	UVSPF.ptsTots.SS.VV,		questTooltips.MW},
			{34, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.CC)),						GetSV(sVarPtsData.ZQ.CC),	UVSPF.ptsTots.ZQ.CC,		GetSV(sVarPtsData.SS.CC),	UVSPF.ptsTots.SS.CC,		questTooltips.CC},
			{35, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.SU)),						GetSV(sVarPtsData.ZQ.SU),	UVSPF.ptsTots.ZQ.SU,		GetSV(sVarPtsData.SS.SU),	UVSPF.ptsTots.SS.SU,		questTooltips.SU},
			{36, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.MM)),						GetSV(sVarPtsData.ZQ.MM),	UVSPF.ptsTots.ZQ.MM,		GetSV(sVarPtsData.SS.MM),	UVSPF.ptsTots.SS.MM,		questTooltips.MM},
			{37, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.NE)),						GetSV(sVarPtsData.ZQ.NE),	UVSPF.ptsTots.ZQ.NE,		GetSV(sVarPtsData.SS.NE),	UVSPF.ptsTots.SS.NE,		questTooltips.NE},
			{38, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.SE)),						GetSV(sVarPtsData.ZQ.SE),	UVSPF.ptsTots.ZQ.SE,		GetSV(sVarPtsData.SS.SE),	UVSPF.ptsTots.SS.SE,		questTooltips.SE},
			{39, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.WS)),						GetSV(sVarPtsData.ZQ.WS),	UVSPF.ptsTots.ZQ.WS,		GetSV(sVarPtsData.SS.WS),	UVSPF.ptsTots.SS.WS,		questTooltips.WS},
			{40, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.TR)),						GetSV(sVarPtsData.ZQ.TR),	UVSPF.ptsTots.ZQ.TR,		GetSV(sVarPtsData.SS.TR),	UVSPF.ptsTots.SS.TR,		questTooltips.TR},
			{41, zf("<<C:1>>",			GZNBId(UVSPF.data.ZId.ZN.BW)),						GetSV(sVarPtsData.ZQ.BW),	UVSPF.ptsTots.ZQ.BW,		GetSV(sVarPtsData.SS.BW),	UVSPF.ptsTots.SS.BW,		questTooltips.BW},
		},
		SQS_SL_T = strF("%d/%d", sVarPtsData.ZQTot, UVSPF.ptsTots.ZQTot),
		SQS_SS_T = strF("%d/%d", sVarPtsData.SSTot, UVSPF.ptsTots.SSTot),
		GDQ = {
			{ 1, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD1)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.BC1)),	GetSV(sVarPtsData.GD.BC1),	UVSPF.ptsTots.GD.BC1,	UVSPF.data.GD.BC1[4]},
			{ 2, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD1)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.BC2)),	GetSV(sVarPtsData.GD.BC2),	UVSPF.ptsTots.GD.BC2,	UVSPF.data.GD.BC2[4]},
			{ 3, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.EH1)),	GetSV(sVarPtsData.GD.EH1),	UVSPF.ptsTots.GD.EH1,	UVSPF.data.GD.EH1[4]},
			{ 4, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.EH2)),	GetSV(sVarPtsData.GD.EH2),	UVSPF.ptsTots.GD.EH2,	UVSPF.data.GD.EH2[4]},
			{ 5, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.CA1)),	GetSV(sVarPtsData.GD.CA1),	UVSPF.ptsTots.GD.CA1,	UVSPF.data.GD.CA1[4]},
			{ 6, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.CA2)),	GetSV(sVarPtsData.GD.CA2),	UVSPF.ptsTots.GD.CA2,	UVSPF.data.GD.CA2[4]},
			{ 7, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD4)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.TI)),	GetSV(sVarPtsData.GD.TI),	UVSPF.ptsTots.GD.TI,		UVSPF.data.GD.TI[4]},
			{ 8, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD5)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.SW)),	GetSV(sVarPtsData.GD.SW),	UVSPF.ptsTots.GD.SW,		UVSPF.data.GD.SW[4]},
			{ 9, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC1)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.SC1)),	GetSV(sVarPtsData.GD.SC1),	UVSPF.ptsTots.GD.SC1,	UVSPF.data.GD.SC1[4]},
			{10, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC1)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.SC2)),	GetSV(sVarPtsData.GD.SC2),	UVSPF.ptsTots.GD.SC2,	UVSPF.data.GD.SC2[4]},
			{11, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.WS1)),	GetSV(sVarPtsData.GD.WS1),	UVSPF.ptsTots.GD.WS1,	UVSPF.data.GD.WS1[4]},
			{12, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.WS2)),	GetSV(sVarPtsData.GD.WS2),	UVSPF.ptsTots.GD.WS2,	UVSPF.data.GD.WS2[4]},
			{13, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.CH1)),	GetSV(sVarPtsData.GD.CH1),	UVSPF.ptsTots.GD.CH1,	UVSPF.data.GD.CH1[4]},
			{14, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.CH2)),	GetSV(sVarPtsData.GD.CH2),	UVSPF.ptsTots.GD.CH2,	UVSPF.data.GD.CH2[4]},
			{15, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC4)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.VF)),	GetSV(sVarPtsData.GD.VF),	UVSPF.ptsTots.GD.VF,		UVSPF.data.GD.VF[4]},
			{16, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC5)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.BH)),	GetSV(sVarPtsData.GD.BH),	UVSPF.ptsTots.GD.BH,		UVSPF.data.GD.BH[4]},
			{17, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP1)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.FG1)),	GetSV(sVarPtsData.GD.FG1),	UVSPF.ptsTots.GD.FG1,	UVSPF.data.GD.FG1[4]},
			{18, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP1)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.FG2)),	GetSV(sVarPtsData.GD.FG2),	UVSPF.ptsTots.GD.FG2,	UVSPF.data.GD.FG2[4]},
			{19, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.DC1)),	GetSV(sVarPtsData.GD.DC1),	UVSPF.ptsTots.GD.DC1,	UVSPF.data.GD.DC1[4]},
			{20, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.DC2)),	GetSV(sVarPtsData.GD.DC2),	UVSPF.ptsTots.GD.DC2,	UVSPF.data.GD.DC2[4]},
			{21, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.AC)),	GetSV(sVarPtsData.GD.AC),	UVSPF.ptsTots.GD.AC,		UVSPF.data.GD.AC[4]},
			{22, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP4)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.DK)),	GetSV(sVarPtsData.GD.DK),	UVSPF.ptsTots.GD.DK,		UVSPF.data.GD.DK[4]},
			{23, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP5)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.BC)),	GetSV(sVarPtsData.GD.BC),	UVSPF.ptsTots.GD.BC,		UVSPF.data.GD.BC[4]},
			{24, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.CH)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.VM)),	GetSV(sVarPtsData.GD.VM),	UVSPF.ptsTots.GD.VM,		UVSPF.data.GD.VM[4]},
			{25, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.CYD)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.ICP)),	GetSV(sVarPtsData.GD.ICP),	UVSPF.ptsTots.GD.ICP,	UVSPF.data.GD.ICP[4]},
			{26, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.CYD)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.WGT)),	GetSV(sVarPtsData.GD.WGT),	UVSPF.ptsTots.GD.WGT,	UVSPF.data.GD.WGT[4]},
			{27, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.CS)),	GetSV(sVarPtsData.GD.CS),	UVSPF.ptsTots.GD.CS,		UVSPF.data.GD.CS[4]},
			{28, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.RM)),	GetSV(sVarPtsData.GD.RM),	UVSPF.ptsTots.GD.RM,		UVSPF.data.GD.RM[4]},
			{29, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.CL)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.BF)),	GetSV(sVarPtsData.GD.BF),	UVSPF.ptsTots.GD.BF,		UVSPF.data.GD.BF[4]},
			{30, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.CL)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.FH)),	GetSV(sVarPtsData.GD.FH),	UVSPF.ptsTots.GD.FH,		UVSPF.data.GD.FH[4]},
			{31, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC5)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.FL)),	GetSV(sVarPtsData.GD.FL),	UVSPF.ptsTots.GD.FL,		UVSPF.data.GD.FL[4]},
			{32, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.SP)),	GetSV(sVarPtsData.GD.SP),	UVSPF.ptsTots.GD.SP,		UVSPF.data.GD.SP[4]},
			{33, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD5)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.MHK)),	GetSV(sVarPtsData.GD.MHK),	UVSPF.ptsTots.GD.MHK,	UVSPF.data.GD.MHK[4]},
			{34, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.MOS)),	GetSV(sVarPtsData.GD.MOS),	UVSPF.ptsTots.GD.MOS,	UVSPF.data.GD.MOS[4]},
			{35, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.GC)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.DoM)),	GetSV(sVarPtsData.GD.DoM),	UVSPF.ptsTots.GD.DoM,	UVSPF.data.GD.DoM[4]},
			{36, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP4)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.FV)),	GetSV(sVarPtsData.GD.FV),	UVSPF.ptsTots.GD.FV,		UVSPF.data.GD.FV[4]},
			{37, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.LM)),	GetSV(sVarPtsData.GD.LM),	UVSPF.ptsTots.GD.LM,		UVSPF.data.GD.LM[4]},
			{38, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.NE)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.MF)),	GetSV(sVarPtsData.GD.MF),	UVSPF.ptsTots.GD.MF,		UVSPF.data.GD.MF[4]},
			{39, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.RO)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.IR)),	GetSV(sVarPtsData.GD.IR),	UVSPF.ptsTots.GD.IR,		UVSPF.data.GD.IR[4]},
			{40, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC5)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.UG)),	GetSV(sVarPtsData.GD.UG),	UVSPF.ptsTots.GD.UG,		UVSPF.data.GD.UG[4]},
			{41, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.BGC)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.SG)),	GetSV(sVarPtsData.GD.SG),	UVSPF.ptsTots.GD.SG,		UVSPF.data.GD.SG[4]},
			{42, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.WS)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.CT)),	GetSV(sVarPtsData.GD.CT),	UVSPF.ptsTots.GD.CT,		UVSPF.data.GD.CT[4]},
			{43, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.CD)),	GetSV(sVarPtsData.GD.CD),	UVSPF.ptsTots.GD.CD,		UVSPF.data.GD.CD[4]},
			{44, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.GC)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.GDN.BDV)),	GetSV(sVarPtsData.GD.BDV),	UVSPF.ptsTots.GD.BDV,	UVSPF.data.GD.BDV[4]},
		},
		GDQ_T = strF("%s: %d/%d", GS(UVSPF_GUI_TOTAL), sVarPtsData.GDTot, UVSPF.ptsTots.GDTot),
		PDGBE = {
			{ 1, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD1)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.AD1)),	GetSV(sVarPtsData.PD.AD1),	UVSPF.ptsTots.PD.AD1,	GetAchLink(UVSPF.data.PD.AD1[2])},
			{ 2, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.AD2)),	GetSV(sVarPtsData.PD.AD2),	UVSPF.ptsTots.PD.AD2,	GetAchLink(UVSPF.data.PD.AD2[2])},
			{ 3, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.AD3)),	GetSV(sVarPtsData.PD.AD3),	UVSPF.ptsTots.PD.AD3,	GetAchLink(UVSPF.data.PD.AD3[2])},
			{ 4, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD4)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.AD4)),	GetSV(sVarPtsData.PD.AD4),	UVSPF.ptsTots.PD.AD4,	GetAchLink(UVSPF.data.PD.AD4[2])},
			{ 5, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.AD5)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.AD5)),	GetSV(sVarPtsData.PD.AD5),	UVSPF.ptsTots.PD.AD5,	GetAchLink(UVSPF.data.PD.AD5[2])},
			{ 6, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC1)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.DC1)),	GetSV(sVarPtsData.PD.DC1),	UVSPF.ptsTots.PD.DC1,	GetAchLink(UVSPF.data.PD.DC1[2])},
			{ 7, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.DC2)),	GetSV(sVarPtsData.PD.DC2),	UVSPF.ptsTots.PD.DC2,	GetAchLink(UVSPF.data.PD.DC2[2])},
			{ 8, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.DC3)),	GetSV(sVarPtsData.PD.DC3),	UVSPF.ptsTots.PD.DC3,	GetAchLink(UVSPF.data.PD.DC3[2])},
			{ 9, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC4)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.DC4)),	GetSV(sVarPtsData.PD.DC4),	UVSPF.ptsTots.PD.DC4,	GetAchLink(UVSPF.data.PD.DC4[2])},
			{10, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.DC5)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.DC5)),	GetSV(sVarPtsData.PD.DC5),	UVSPF.ptsTots.PD.DC5,	GetAchLink(UVSPF.data.PD.DC5[2])},
			{11, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP1)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.EP1)),	GetSV(sVarPtsData.PD.EP1),	UVSPF.ptsTots.PD.EP1,	GetAchLink(UVSPF.data.PD.EP1[2])},
			{12, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP2)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.EP2)),	GetSV(sVarPtsData.PD.EP2),	UVSPF.ptsTots.PD.EP2,	GetAchLink(UVSPF.data.PD.EP2[2])},
			{13, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP3)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.EP3)),	GetSV(sVarPtsData.PD.EP3),	UVSPF.ptsTots.PD.EP3,	GetAchLink(UVSPF.data.PD.EP3[2])},
			{14, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP4)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.EP4)),	GetSV(sVarPtsData.PD.EP4),	UVSPF.ptsTots.PD.EP4,	GetAchLink(UVSPF.data.PD.EP4[2])},
			{15, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.EP5)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.EP5)),	GetSV(sVarPtsData.PD.EP5),	UVSPF.ptsTots.PD.EP5,	GetAchLink(UVSPF.data.PD.EP5[2])},
			{16, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.CH)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.CH)),	GetSV(sVarPtsData.PD.CH),	UVSPF.ptsTots.PD.CH,		GetAchLink(UVSPF.data.PD.CH[2])},
			{17, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.RO)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.WOO)),	GetSV(sVarPtsData.PD.WOO),	UVSPF.ptsTots.PD.WOO,	GetAchLink(UVSPF.data.PD.WOO[2])},
			{18, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.RO)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.WRK)),	GetSV(sVarPtsData.PD.WRK),	UVSPF.ptsTots.PD.WRK,	GetAchLink(UVSPF.data.PD.WRK[2])},
			{19, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.VV)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.VFW)),	GetSV(sVarPtsData.PD.VFW),	UVSPF.ptsTots.PD.VFW,	GetAchLink(UVSPF.data.PD.VFW[2])},
			{20, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.VV)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.VNC)),	GetSV(sVarPtsData.PD.VNC),	UVSPF.ptsTots.PD.VNC,	GetAchLink(UVSPF.data.PD.VNC[2])},
			{21, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.SU)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.SKW)),	GetSV(sVarPtsData.PD.SKW),	UVSPF.ptsTots.PD.SKW,	GetAchLink(UVSPF.data.PD.SKW[2])},
			{22, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.SU)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.SSH)),	GetSV(sVarPtsData.PD.SSH),	UVSPF.ptsTots.PD.SSH,	GetAchLink(UVSPF.data.PD.SSH[2])},
			{23, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.NE)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.OC)),	GetSV(sVarPtsData.PD.OC),	UVSPF.ptsTots.PD.OC,		GetAchLink(UVSPF.data.PD.OC[2])},
			{24, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.NE)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.RN)),	GetSV(sVarPtsData.PD.RN),	UVSPF.ptsTots.PD.RN,		GetAchLink(UVSPF.data.PD.RN[2])},
			{25, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.WS)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.LT)),	GetSV(sVarPtsData.PD.LT),	UVSPF.ptsTots.PD.LT,		GetAchLink(UVSPF.data.PD.LT[2])},
			{26, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.BGC)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.NK)),	GetSV(sVarPtsData.PD.NK),	UVSPF.ptsTots.PD.NK,		GetAchLink(UVSPF.data.PD.NK[2])},
			{27, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.BW)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.ZA)),	GetSV(sVarPtsData.PD.ZA),	UVSPF.ptsTots.PD.ZA,		GetAchLink(UVSPF.data.PD.ZA[2])},
			{28, zf("<<C:1>>", GZNBId(UVSPF.data.ZId.ZN.BW)),	zf("<<C:1>>", GZNBId(UVSPF.data.ZId.PDN.TSH)),	GetSV(sVarPtsData.PD.TSH),	UVSPF.ptsTots.PD.TSH,		GetAchLink(UVSPF.data.PD.TSH[2])},
		},
		PDGBE_T = strF("%s: %d/%d", GS(UVSPF_GUI_TOTAL), sVarPtsData.PDTot, UVSPF.ptsTots.PDTot),
		CharacterTot = strF("%s: %d/%d", GS(UVSPF_GUI_CHAR_TOTAL), sVarPtsData.Tot, UVSPF.ptsTots.Tot),
	}
end

local function UVSPF_SetupData(charId)
	if(charId == GCCId()) then
		--Reset All Points to Zero.
		UVSPF.ptsData = UVSPF_LTF:SimpleResetTable(UVSPF.ptsData, 0)
		
		--Update Level Points.
		UVSPF_SetLevelPoints()
		
		--Update Quest Points.
		UVSPF_SetQuestPoints()
		
		--Update Public Dungeon Points.
		UVSPF_SetPublicDungeonPoints()

		--Update Skyshard Points.
		UVSPF_SetSkyshardPoints()
		
		--Update Alliance War Rank Points.
		UVSPF_SetAllianceWarRankPoints()
		
		--Update MaelAr Arena Point.
		UVSPF_SetMaelArPoints()
		
		--Update VatAr Arena Point.
		UVSPF_SetVatArPoints()
		
		--Update Folium Discognitum Points.
		UVSPF_SetFoliumDiscognitumPoints()
		
		--Update General Points.
		UVSPF_SetGeneralPoints()
		
		--Update Tot Points.
		UVSPF_SetTotPoints()
		
		--Update the GUI Table.
		UVSPF_UpdateGUITable()
		
		--Update the saved variables.
		UVSPF_UpdateAllSavedVars()
	else
		--Load selected character data.
		UVSPF_LoadData(charId)
	end
end

function UVSPF:UpdateDataLines()
	local dataLines_GSP, dataLines_SQS, dataLines_GDQ, dataLines_PDGBE, tempTable = {},{},{},{},{}
	
	UVSPF_SetupData(selectedChar)
	
	for i = 1, #UVSPF.GUI.GSP do
		table.insert(dataLines_GSP, {
			source = UVSPF.GUI.GSP[i][2],
			progress = (UVSPF.GUI.GSP[i][3] == 0 and strF("%s%d/%d|r", UVSPF_rgbToHex(UVSPF.settings.GSP.needColor), UVSPF.GUI.GSP[i][3], UVSPF.GUI.GSP[i][4]) or
				(UVSPF.GUI.GSP[i][3] < UVSPF.GUI.GSP[i][4] and strF("%s%d/%d|r", UVSPF_rgbToHex(UVSPF.settings.GSP.progColor == nil and UVSPF.settings.GSP.progColor or UVSPF.settings.GSP.progColor), UVSPF.GUI.GSP[i][3], UVSPF.GUI.GSP[i][4]) or
					strF("%s%d/%d|r", UVSPF_rgbToHex(UVSPF.settings.GSP.doneColor), UVSPF.GUI.GSP[i][3], UVSPF.GUI.GSP[i][4])))
		})
	end
	
	tempTable = UVSPF_LTF:SortTable(UVSPF.GUI.SQS, UVSPF.settings.SQS.sortCol)
	for i = 1, #tempTable do
		table.insert(dataLines_SQS, {
			zone = tempTable[i][2],
			quests = (tempTable[i][4] > 0
				and (tempTable[i][3] == 0 and strF("%s%d/%d|r", UVSPF_rgbToHex(UVSPF.settings.SQS.needColorZQ), tempTable[i][3], tempTable[i][4]) or
					(tempTable[i][3] < tempTable[i][4] and strF("%s%d/%d|r", UVSPF_rgbToHex(UVSPF.settings.SQS.progColorZQ), tempTable[i][3], tempTable[i][4]) or
						strF("%s%d/%d|r", UVSPF_rgbToHex(UVSPF.settings.SQS.doneColorZQ), tempTable[i][3], tempTable[i][4])))
				or "-"),
			skyshards = (tempTable[i][5] == 0 and strF("%s%d/%d|r", UVSPF_rgbToHex(UVSPF.settings.SQS.needColorSS), tempTable[i][5], tempTable[i][6]) or
				(tempTable[i][5] < tempTable[i][6] and strF("%s%d/%d|r", UVSPF_rgbToHex(UVSPF.settings.SQS.progColorSS), tempTable[i][5], tempTable[i][6]) or
					strF("%s%d/%d|r", UVSPF_rgbToHex(UVSPF.settings.SQS.doneColorSS), tempTable[i][5], tempTable[i][6]))),
		})
	end
	
	tempTable = UVSPF_LTF:SortTable(UVSPF.GUI.GDQ, UVSPF.settings.GDQ.sortCol)
	for i = 1, #tempTable do
		table.insert(dataLines_GDQ, {
			zone = tempTable[i][2],
			dungeon = tempTable[i][3],
			progress = (tempTable[i][4] < tempTable[i][5] and strF("%s%d/%d|r", UVSPF_rgbToHex(UVSPF.settings.GDQ.needColor), tempTable[i][4], tempTable[i][5]) or strF("%s%d/%d|r", UVSPF_rgbToHex(UVSPF.settings.GDQ.doneColor), tempTable[i][4], tempTable[i][5])),
		})
	end
	
	tempTable = UVSPF_LTF:SortTable(UVSPF.GUI.PDGBE, UVSPF.settings.PDB.sortCol)
	for i = 1, #tempTable do
		table.insert(dataLines_PDGBE, {
			zone = tempTable[i][2],
			dungeon = tempTable[i][3],
			progress = (tempTable[i][4] < tempTable[i][5] and strF("%s%d/%d|r", UVSPF_rgbToHex(UVSPF.settings.PDB.needColor), tempTable[i][4], tempTable[i][5]) or strF("%s%d/%d|r", UVSPF_rgbToHex(UVSPF.settings.PDB.doneColor), tempTable[i][4], tempTable[i][5])),
		})
	end
	
	
	UVSPF_GUI_Header_Title:SetText(GS(UVSPF_GUI_TITLE))
	UVSPF_GUI_Body_GSP:SetText(GS(UVSPF_GUI_GSP))
	UVSPF_GUI_Body_GSP_Source:SetText(GS(UVSPF_GUI_SOURCE))
	UVSPF_GUI_Body_GSP_Progress:SetText(GS(UVSPF_GUI_PROGRESS))
	
	UVSPF_GUI_Body_SQS:SetText(GS(UVSPF_GUI_SQS))
	UVSPF_GUI_Body_SQS_Z:SetText(GS(UVSPF_GUI_ZONE))
	UVSPF_GUI_Body_SQS_SL:SetText(GS(UVSPF_GUI_STORYLINE))
	UVSPF_GUI_Body_SQS_SS:SetText(GS(UVSPF_GUI_SKYSHARDS))
	UVSPF_GUI_Body_SQS_Z_T:SetText(GS(UVSPF_GUI_TOTAL..":"))
	
	UVSPF_GUI_Body_GDQ:SetText(GS(UVSPF_GUI_GDQ))
	UVSPF_GUI_Body_GDQ_Z:SetText(GS(UVSPF_GUI_ZONE))
	UVSPF_GUI_Body_GDQ_D:SetText(GS(UVSPF_GUI_GROUP_DUNGEON))
	UVSPF_GUI_Body_GDQ_P:SetText(GS(UVSPF_GUI_PROGRESS))
	
	UVSPF_GUI_Body_PDGBE:SetText(GS(UVSPF_GUI_PDB))
	UVSPF_GUI_Body_PDGBE_Z:SetText(GS(UVSPF_GUI_ZONE))
	UVSPF_GUI_Body_PDGBE_D:SetText(GS(UVSPF_GUI_PUBLIC_DUNGEON))
	UVSPF_GUI_Body_PDGBE_P:SetText(GS(UVSPF_GUI_PROGRESS))
	
	
	UVSPF_GUI_Body_GSP_ListHolder.dataLines = dataLines_GSP
	UVSPF_GUI_Body_GSP_ListHolder:SetParent(UVSPF_GUI_Body)
	UVSPF_GUI_Body_SQS_ListHolder.dataLines = dataLines_SQS
	UVSPF_GUI_Body_SQS_ListHolder:SetParent(UVSPF_GUI_Body)
	UVSPF_GUI_Body_GDQ_ListHolder.dataLines = dataLines_GDQ
	UVSPF_GUI_Body_GDQ_ListHolder:SetParent(UVSPF_GUI_Body)
	UVSPF_GUI_Body_PDGBE_ListHolder.dataLines = dataLines_PDGBE
	UVSPF_GUI_Body_PDGBE_ListHolder:SetParent(UVSPF_GUI_Body)
	
	UVSPF_GUI_Body_GSP_T:SetText(UVSPF.GUI.GSP_T)
	UVSPF_GUI_Body_SQS_SL_T:SetText(UVSPF.GUI.SQS_SL_T)
	UVSPF_GUI_Body_SQS_SS_T:SetText(UVSPF.GUI.SQS_SS_T)
	UVSPF_GUI_Body_GDQ_T:SetText(UVSPF.GUI.GDQ_T)
	UVSPF_GUI_Body_PDGBE_T:SetText(UVSPF.GUI.PDGBE_T)
	UVSPF_GUI_Footer_CharacterTotal:SetText(UVSPF.GUI.CharacterTot)
	
	UVSPF:InitializeDataLines()
end

function UVSPF:FillLine(currLine, currItem)
	local cln, clsrc, clz, clq, clss, cld, clp, cisrc, ciz, ciq, ciss, cid, cip = currLine:GetParent():GetName(), currLine.source, currLine.zone, currLine.quests, currLine.skyshards, currLine.dungeon, currLine.progress, currItem.source, currItem.zone, currItem.quests, currItem.skyshards, currItem.dungeon, currItem.progress
	
	if currItem == nil then
		if(cln == "UVSPF_GUI_Body_GSP_ListHolder") then
			clsrc:SetText("")
			clp:SetText("")
		elseif(cln == "UVSPF_GUI_Body_SQS_ListHolder") then
			clz:SetText("")
			clq:SetText("")
			clss:SetText("")
		elseif(cln == "UVSPF_GUI_Body_GDQ_ListHolder") then
			clz:SetText("")
			cld:SetText("")
			clp:SetText("")
		elseif(cln == "UVSPF_GUI_Body_PDGBE_ListHolder") then
			clz:SetText("")
			cld:SetText("")
			clp:SetText("")
		end
	else
		if(cln == "UVSPF_GUI_Body_GSP_ListHolder") then
			clsrc:SetText(cisrc)
			clp:SetText(cip)
		elseif(cln == "UVSPF_GUI_Body_SQS_ListHolder") then
			clz:SetText(ciz)
			clq:SetText(ciq)
			clss:SetText(ciss)
		elseif(cln == "UVSPF_GUI_Body_GDQ_ListHolder") then
			clz:SetText(ciz)
			cld:SetText(cid)
			clp:SetText(cip)
		elseif(cln == "UVSPF_GUI_Body_PDGBE_ListHolder") then
			clz:SetText(ciz)
			cld:SetText(cid)
			clp:SetText(cip)
		end
	end
end

function UVSPF:InitializeDataLines()
	local currLine, currData
	for i = 1, #UVSPF.GUI.GSP do
		currLine = UVSPF_GUI_Body_GSP_ListHolder.lines[i]
		currData = UVSPF_GUI_Body_GSP_ListHolder.dataLines[i]
		UVSPF:FillLine(currLine, (currData ~= nil and currData or nil))
		
		if(UVSPF.GUI.GSP[i][5] ~= nil) then
			-- tooltip text
			UVSPF_GUI_Body_GSP_ListHolder.lines[i].data = {tooltipText = UVSPF.GUI.GSP[i][5]}
			
			-- tooltip handlers
			UVSPF_GUI_Body_GSP_ListHolder.lines[i]:SetHandler("OnMouseEnter", ZO_Options_OnMouseEnter)
			UVSPF_GUI_Body_GSP_ListHolder.lines[i]:SetHandler("OnMouseExit", ZO_Options_OnMouseExit)
		end
	end
	
	for i = 1, #UVSPF.GUI.SQS do
		currLine = UVSPF_GUI_Body_SQS_ListHolder.lines[i]
		currData = UVSPF_GUI_Body_SQS_ListHolder.dataLines[i]
		UVSPF:FillLine(currLine, (currData ~= nil and currData or nil))
		
		if(UVSPF.GUI.SQS[i][7] ~= nil) then
			-- tooltip text
			UVSPF_GUI_Body_SQS_ListHolder.lines[i].data = {tooltipText = UVSPF.GUI.SQS[i][7]}
			
			-- tooltip handlers
			UVSPF_GUI_Body_SQS_ListHolder.lines[i]:SetHandler("OnMouseEnter", ZO_Options_OnMouseEnter)
			UVSPF_GUI_Body_SQS_ListHolder.lines[i]:SetHandler("OnMouseExit", ZO_Options_OnMouseExit)
		end
	end
	
	for i = 1, #UVSPF.GUI.GDQ do
		currLine = UVSPF_GUI_Body_GDQ_ListHolder.lines[i]
		currData = UVSPF_GUI_Body_GDQ_ListHolder.dataLines[i]
		UVSPF:FillLine(currLine, (currData ~= nil and currData or nil))
		
		if(UVSPF.GUI.GDQ[i][6] ~= nil) then
			-- tooltip text
			UVSPF_GUI_Body_GDQ_ListHolder.lines[i].data = {tooltipText = UVSPF.GUI.GDQ[i][6]}
			
			-- tooltip handlers
			UVSPF_GUI_Body_GDQ_ListHolder.lines[i]:SetHandler("OnMouseEnter", ZO_Options_OnMouseEnter)
			UVSPF_GUI_Body_GDQ_ListHolder.lines[i]:SetHandler("OnMouseExit", ZO_Options_OnMouseExit)
		end
	end
	
	for i = 1, #UVSPF.GUI.PDGBE do
		currLine = UVSPF_GUI_Body_PDGBE_ListHolder.lines[i]
		currData = UVSPF_GUI_Body_PDGBE_ListHolder.dataLines[i]
		UVSPF:FillLine(currLine, (currData ~= nil and currData or nil))
		
		if(UVSPF.GUI.PDGBE[i][6] ~= nil) then
			-- tooltip text
			UVSPF_GUI_Body_PDGBE_ListHolder.lines[i].data = {tooltipText = UVSPF.GUI.PDGBE[i][6]}
			
			-- tooltip handlers
			UVSPF_GUI_Body_PDGBE_ListHolder.lines[i]:SetHandler("OnMouseEnter", ZO_Options_OnMouseEnter)
			UVSPF_GUI_Body_PDGBE_ListHolder.lines[i]:SetHandler("OnMouseExit", ZO_Options_OnMouseExit)
		end
	end
end

function UVSPF:ToggleWindow()
	UVSPF.active = not UVSPF.active
	if(UVSPF.active) then UVSPF:UpdateDataLines() end
	UVSPF_GUI:SetHidden(not UVSPF.active)
end


function UVSPF:CreateLine(i, UVSPF_predecessor, UVSPF_parent)
	if(UVSPF_parent:GetName() == "UVSPF_GUI_Body_GSP_ListHolder") then
		local UVSPF_record = CreateControlFromVirtual("UVSPF_GSP_Row_", UVSPF_parent, "UVSPF_GeneralTemplate", i)
		
		UVSPF_record.source = UVSPF_record:GetNamedChild("_Source")
		UVSPF_record.progress = UVSPF_record:GetNamedChild("_Progress")
		
		UVSPF_record.source:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.GSP.font].."|14")
		UVSPF_record.progress:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.GSP.font].."|14")
		
		UVSPF_record:SetHidden(false)
		UVSPF_record:SetMouseEnabled(true)
		UVSPF_record:SetHeight("18")
		
		if i == 1 then
			UVSPF_record:SetAnchor(TOPLEFT, UVSPF_GUI_Body_GSP_ListHolder, TOPLEFT, 0, 0)
			UVSPF_record:SetAnchor(TOPRIGHT, UVSPF_GUI_Body_GSP_ListHolder, TOPRIGHT, 0, 0)
		else
			UVSPF_record:SetAnchor(TOPLEFT, UVSPF_predecessor, BOTTOMLEFT, 0, UVSPF_GUI_Body_GSP_ListHolder.rowHeight)
			UVSPF_record:SetAnchor(TOPRIGHT, UVSPF_predecessor, BOTTOMRIGHT, 0, UVSPF_GUI_Body_GSP_ListHolder.rowHeight)
		end
		UVSPF_record:SetParent(UVSPF_GUI_Body_GSP_ListHolder)
		return UVSPF_record
	elseif(UVSPF_parent:GetName() == "UVSPF_GUI_Body_SQS_ListHolder") then
		local UVSPF_record = CreateControlFromVirtual("UVSPF_SQS_Row_", UVSPF_parent, "UVSPF_SQSSTemplate", i)
		
		UVSPF_record.zone = UVSPF_record:GetNamedChild("_Zone")
		UVSPF_record.quests = UVSPF_record:GetNamedChild("_Quests")
		UVSPF_record.skyshards = UVSPF_record:GetNamedChild("_Skyshards")
		
		UVSPF_record.zone:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.SQS.font].."|14")
		UVSPF_record.quests:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.SQS.font].."|14")
		UVSPF_record.skyshards:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.SQS.font].."|14")
		
		UVSPF_record:SetHidden(false)
		UVSPF_record:SetMouseEnabled(true)
		UVSPF_record:SetHeight("18")
		
		if i == 1 then
			UVSPF_record:SetAnchor(TOPLEFT, UVSPF_GUI_Body_SQS_ListHolder, TOPLEFT, 0, 0)
			UVSPF_record:SetAnchor(TOPRIGHT, UVSPF_GUI_Body_SQS_ListHolder, TOPRIGHT, 0, 0)
		else
			UVSPF_record:SetAnchor(TOPLEFT, UVSPF_predecessor, BOTTOMLEFT, 0, UVSPF_GUI_Body_SQS_ListHolder.rowHeight)
			UVSPF_record:SetAnchor(TOPRIGHT, UVSPF_predecessor, BOTTOMRIGHT, 0, UVSPF_GUI_Body_SQS_ListHolder.rowHeight)
		end
		UVSPF_record:SetParent(UVSPF_GUI_Body_SQS_ListHolder)
		return UVSPF_record
	elseif(UVSPF_parent:GetName() == "UVSPF_GUI_Body_GDQ_ListHolder") then
		local UVSPF_record = CreateControlFromVirtual("UVSPF_GDQ_Row_", UVSPF_parent, "UVSPF_GDQTemplate", i)
		
		UVSPF_record.zone = UVSPF_record:GetNamedChild("_Zone")
		UVSPF_record.dungeon = UVSPF_record:GetNamedChild("_Dungeon")
		UVSPF_record.progress = UVSPF_record:GetNamedChild("_Progress")
		
		UVSPF_record.zone:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.GDQ.font].."|14")
		UVSPF_record.dungeon:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.GDQ.font].."|14")
		UVSPF_record.progress:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.GDQ.font].."|14")
		
		UVSPF_record:SetHidden(false)
		UVSPF_record:SetMouseEnabled(true)
		UVSPF_record:SetHeight("18")
		
		if i == 1 then
			UVSPF_record:SetAnchor(TOPLEFT, UVSPF_GUI_Body_GDQ_ListHolder, TOPLEFT, 0, 0)
			UVSPF_record:SetAnchor(TOPRIGHT, UVSPF_GUI_Body_GDQ_ListHolder, TOPRIGHT, 0, 0)
		else
			UVSPF_record:SetAnchor(TOPLEFT, UVSPF_predecessor, BOTTOMLEFT, 0, UVSPF_GUI_Body_GDQ_ListHolder.rowHeight)
			UVSPF_record:SetAnchor(TOPRIGHT, UVSPF_predecessor, BOTTOMRIGHT, 0, UVSPF_GUI_Body_GDQ_ListHolder.rowHeight)
		end
		UVSPF_record:SetParent(UVSPF_GUI_Body_GDQ_ListHolder)
		return UVSPF_record
	elseif(UVSPF_parent:GetName() == "UVSPF_GUI_Body_PDGBE_ListHolder") then
		local UVSPF_record = CreateControlFromVirtual("UVSPF_PDGBE_Row_", UVSPF_parent, "UVSPF_PDGBETemplate", i)
		
		UVSPF_record.zone = UVSPF_record:GetNamedChild("_Zone")
		UVSPF_record.dungeon = UVSPF_record:GetNamedChild("_Dungeon")
		UVSPF_record.progress = UVSPF_record:GetNamedChild("_Progress")
		
		UVSPF_record.zone:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.PDB.font].."|14")
		UVSPF_record.dungeon:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.PDB.font].."|14")
		UVSPF_record.progress:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.PDB.font].."|14")
		
		UVSPF_record:SetHidden(false)
		UVSPF_record:SetMouseEnabled(true)
		UVSPF_record:SetHeight("18")
		
		if i == 1 then
			UVSPF_record:SetAnchor(TOPLEFT, UVSPF_GUI_Body_PDGBE_ListHolder, TOPLEFT, 0, 0)
			UVSPF_record:SetAnchor(TOPRIGHT, UVSPF_GUI_Body_PDGBE_ListHolder, TOPRIGHT, 0, 0)
		else
			UVSPF_record:SetAnchor(TOPLEFT, UVSPF_predecessor, BOTTOMLEFT, 0, UVSPF_GUI_Body_PDGBE_ListHolder.rowHeight)
			UVSPF_record:SetAnchor(TOPRIGHT, UVSPF_predecessor, BOTTOMRIGHT, 0, UVSPF_GUI_Body_PDGBE_ListHolder.rowHeight)
		end
		UVSPF_record:SetParent(UVSPF_GUI_Body_PDGBE_ListHolder)
		return UVSPF_record
	end
end

function UVSPF:CreateListHolders()
	local UVSPF_predecessor = nil
	UVSPF_GUI_Body_GSP_ListHolder.dataLines = {}
	UVSPF_GUI_Body_GSP_ListHolder.lines = {}
	for i = 1, #UVSPF.GUI.GSP do 
		UVSPF_GUI_Body_GSP_ListHolder.lines[i] = UVSPF:CreateLine(i, UVSPF_predecessor, UVSPF_GUI_Body_GSP_ListHolder)
		UVSPF_predecessor = UVSPF_GUI_Body_GSP_ListHolder.lines[i]
	end
	
	UVSPF_predecessor = nil
	UVSPF_GUI_Body_SQS_ListHolder.dataLines = {}
	UVSPF_GUI_Body_SQS_ListHolder.lines = {}
	for i = 1, #UVSPF.GUI.SQS do
		UVSPF_GUI_Body_SQS_ListHolder.lines[i] = UVSPF:CreateLine(i, UVSPF_predecessor, UVSPF_GUI_Body_SQS_ListHolder)
		UVSPF_predecessor = UVSPF_GUI_Body_SQS_ListHolder.lines[i]
	end
	
	UVSPF_predecessor = nil
	UVSPF_GUI_Body_GDQ_ListHolder.dataLines = {}
	UVSPF_GUI_Body_GDQ_ListHolder.lines = {}
	for i = 1, #UVSPF.GUI.GDQ do
		UVSPF_GUI_Body_GDQ_ListHolder.lines[i] = UVSPF:CreateLine(i, UVSPF_predecessor, UVSPF_GUI_Body_GDQ_ListHolder)
		UVSPF_predecessor = UVSPF_GUI_Body_GDQ_ListHolder.lines[i]
	end
	
	UVSPF_predecessor = nil
	UVSPF_GUI_Body_PDGBE_ListHolder.dataLines = {}
	UVSPF_GUI_Body_PDGBE_ListHolder.lines = {}
	for i = 1, #UVSPF.GUI.PDGBE do
		UVSPF_GUI_Body_PDGBE_ListHolder.lines[i] = UVSPF:CreateLine(i, UVSPF_predecessor, UVSPF_GUI_Body_PDGBE_ListHolder)
		UVSPF_predecessor = UVSPF_GUI_Body_PDGBE_ListHolder.lines[i]
	end
	
	UVSPF:UpdateDataLines()
end

local function UVSPF_UpdateDataTable()
	UVSPF:SetupValues()
	UVSPF_GUI_Body_GSP_T:SetText(strF("%s: %d/%d", GS(UVSPF_GUI_TOTAL), UVSPF.ptsData.GenTot, UVSPF.ptsTots.GenTot))
	UVSPF_GUI_Body_SQS_SL_T:SetText(strF("%d/%d", UVSPF.ptsData.ZQTot, UVSPF.ptsTots.ZQTot))
	UVSPF_GUI_Body_SQS_SS_T:SetText(strF("%d/%d", UVSPF.ptsData.SSTot, UVSPF.ptsTots.SSTot))
	UVSPF_GUI_Body_GDQ_T:SetText(strF("%s: %d/%d", GS(UVSPF_GUI_TOTAL), UVSPF.ptsData.GDTot, UVSPF.ptsTots.GDTot))
	UVSPF_GUI_Body_PDGBE_T:SetText(strF("%s: %d/%d", GS(UVSPF_GUI_TOTAL), UVSPF.ptsData.PDTot, UVSPF.ptsTots.PDTot))
	UVSPF_GUI_Footer_CharacterTotal:SetText(strF("%s: %d/%d", GS(UVSPF_GUI_CHAR_TOTAL), UVSPF.ptsData.Tot, UVSPF.ptsTots.Tot))
end

function UVSPF:SetupValues()
	--Reset All Points to Zero.
	UVSPF.ptsData = UVSPF_LTF:SimpleResetTable(UVSPF.ptsData, 0)
	
	--Update Level Points.
	UVSPF_SetLevelPoints()
	
	--Update Quest Points.
	UVSPF_SetQuestPoints()
	
	--Update Public Dungeon Points.
	UVSPF_SetPublicDungeonPoints()

	--Update Skyshard Points.
	UVSPF_SetSkyshardPoints()
	
	--Update Alliance War Rank Points.
	UVSPF_SetAllianceWarRankPoints()
	
	--Update MaelAr Arena Point.
	UVSPF_SetMaelArPoints()
	
	--Update VatAr Arena Point.
	UVSPF_SetVatArPoints()
	
	--Update Folium Discognitum Points.
	UVSPF_SetFoliumDiscognitumPoints()
	
	--Update General Points.
	UVSPF_SetGeneralPoints()
	
	--Update Tot Points.
	UVSPF_SetTotPoints()
	
	--Update the GUI Table.
	UVSPF_UpdateGUITable()
	
	--Set the window size and position.
	UVSPF_GUI:ClearAnchors()
	UVSPF_GUI:SetAnchor(CENTER, GuiRoot, CENTER, 0, 0)
	UVSPF_GUI:SetHeight(UVSPF_GUI_Header:GetHeight() + #UVSPF.GUI.GDQ * 18 + UVSPF_GUI_Footer:GetHeight() + 18 + 76)
	
	--Add information to window.
	UVSPF:CreateListHolders()
	
	UVSPF_GUI_Header:SetParent(UVSPF_GUI)
	UVSPF_GUI_Body:SetParent(UVSPF_GUI)
	UVSPF_GUI_Footer:SetParent(UVSPF_GUI)
	
	UVSPF_GUI_Body_GSP_ListHolder:SetParent(UVSPF_GUI_Body)
	UVSPF_GUI_Body_SQS_ListHolder:SetParent(UVSPF_GUI_Body)
	UVSPF_GUI_Body_GDQ_ListHolder:SetParent(UVSPF_GUI_Body)
	UVSPF_GUI_Body_PDGBE_ListHolder:SetParent(UVSPF_GUI_Body)
	
	UVSPF_GUI_Header_Title:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|30")
	UVSPF_GUI_Body_GSP:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|16")
	UVSPF_GUI_Body_GSP_Source:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|14")
	UVSPF_GUI_Body_GSP_Progress:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|14")
	UVSPF_GUI_Body_GSP_T:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|14")
	
	UVSPF_GUI_Body_SQS:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|16")
	UVSPF_GUI_Body_SQS_Z:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|14")
	UVSPF_GUI_Body_SQS_SL:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|14")
	UVSPF_GUI_Body_SQS_SS:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|14")
	UVSPF_GUI_Body_SQS_Z_T:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|14")
	UVSPF_GUI_Body_SQS_SL_T:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|14")
	UVSPF_GUI_Body_SQS_SS_T:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|14")
	
	UVSPF_GUI_Body_GDQ:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|16")
	UVSPF_GUI_Body_GDQ_Z:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|14")
	UVSPF_GUI_Body_GDQ_D:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|14")
	UVSPF_GUI_Body_GDQ_P:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|14")
	UVSPF_GUI_Body_GDQ_T:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|14")
	
	UVSPF_GUI_Body_PDGBE:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|16")
	UVSPF_GUI_Body_PDGBE_Z:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|14")
	UVSPF_GUI_Body_PDGBE_D:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|14")
	UVSPF_GUI_Body_PDGBE_P:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|14")
	UVSPF_GUI_Body_PDGBE_T:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|14")
	
	UVSPF_GUI_Footer_CharacterTotal:SetFont(UVSPF.Options.Font.Fonts[UVSPF.settings.title.font].."|24")
end

function UVSPF:HelpSlash()
	d(GS(UVSPF_MSG_CMD_TITLE))
	d(strF(GS(UVSPF_MSG_CMD_OPTION), (UVSPF.active and GS(UVSPF_MSG_DEACTVATE) or GS(UVSPF_MSG_ACTIVATE))))
end

function UVSPF:BadSlash()
	d(GS(UVSPF_MSG_BAD_SLASH))
	d(GS(UVSPF_MSG_CMD_TITLE))
	d(strF(GS(UVSPF_MSG_CMD_OPTION), (UVSPF.active and GS(UVSPF_MSG_DEACTVATE) or GS(UVSPF_MSG_ACTIVATE))))
end

function UVSPF:TestHarness()
	d(GS(UVSPF_MSG_HACK))
end

local function UVSPF_LoadSettings(charId)
	if(UVSPF_CheckSavedVars(UVSPF.sVar.settings[charId])) then
		UVSPF.settings = UVSPF_LTF:CopyTable(UVSPF.sVar.settings[charId])
		
		if(UVSPF.settings.GSP.progColor == nil) then
			UVSPF.settings.GSP.progColor = UVSPF.settings.GSP.progColor == nil and {1, 1, 1} or UVSPF.settings.GSP.progColor
			UVSPF.sVar.settings[charId].GSP.progColor = UVSPF.settings.GSP.progColor
		end
		
		if(UVSPF.settings.SQS.progColorSS == nil) then
			UVSPF.settings.SQS.progColorSS = UVSPF.settings.SQS.progColorSS == nil and {0.7843, 0.3922, 0} or UVSPF.settings.SQS.progColorSS
			UVSPF.sVar.settings[charId].SQS.progColorSS = UVSPF.settings.SQS.progColorSS
		end
		
		if(UVSPF.settings.SQS.progColorZQ == nil) then
			UVSPF.settings.SQS.progColorZQ = UVSPF.settings.SQS.progColorZQ == nil and {0.7843, 0.3922, 0} or UVSPF.settings.SQS.progColorZQ
			UVSPF.sVar.settings[charId].SQS.progColorZQ = UVSPF.settings.SQS.progColorZQ
		end
		
		UVSPF.settings.MWC = (UVSPF.sVar.settings[charId].SSC and false or UVSPF.sVar.settings[charId].MWC)
		UVSPF.settings.SSC = (UVSPF.sVar.settings[charId].MWC and false or UVSPF.sVar.settings[charId].SSC)
		UVSPF.sVar.settings[charId].MWC = (UVSPF.settings.SSC and false or UVSPF.settings.MWC)
		UVSPF.sVar.settings[charId].SSC = (UVSPF.settings.MWC and false or UVSPF.settings.SSC)
	end
end

local function UVSPF_SetSelectedChar(charName)
	for i = 1, #UVSPF.charData do
		if(charName == UVSPF.charData[i].charName) then
			selectedChar = UVSPF.charData[i].charId
			break
		end
	end
end

local function UVSPF_CreateCharList()
	UVSPF_GUI_Header_CharList.comboBox = UVSPF_GUI_Header_CharList.comboBox or ZO_ComboBox_ObjectFromContainer(UVSPF_GUI_Header_CharList)
	local UVSPF_comboBox = UVSPF_GUI_Header_CharList.comboBox
	
	-- tooltip text
	UVSPF_GUI_Header_CharList.data = {tooltipText = "Select a character to view. You must have logged in on the selected character with this addon active for information to populate."}
	
	-- tooltip handlers
	UVSPF_GUI_Header_CharList:SetHandler("OnMouseEnter", ZO_Options_OnMouseEnter)
	UVSPF_GUI_Header_CharList:SetHandler("OnMouseExit", ZO_Options_OnMouseExit)
	
	local name, id = nil, nil
	UVSPF.charNames = {}
	UVSPF.charData = {}
	for k,_ in ipairs(UVSPF.sVar.charInfo) do
		name, _, _, _, _, _, id, _ = GetCharacterInfo(k)
		UVSPF.charNames[k] = UVSPF.sVar.charInfo[k].charName
		UVSPF.charData[k] = {
			charId = UVSPF.sVar.charInfo[k].charId,
			charName = UVSPF.sVar.charInfo[k].charName,
		}
		
		if(GCCId() == UVSPF.charData[k].charId) then
			currentCharName = UVSPF.charData[k].charName
			selectedChar = UVSPF.charData[k].charId
		end
	end
	
	function OnItemSelect(_, choiceText, choice)
		UVSPF_SetSelectedChar(choiceText)
		UVSPF:UpdateDataLines()
		PlaySound(SOUNDS.POSITIVE_CLICK)
	end

	UVSPF_comboBox:SetSortsItems(false)
	
	for k,_ in ipairs(UVSPF.charNames) do
		UVSPF_comboBox:AddItem(UVSPF_comboBox:CreateItemEntry(UVSPF.charNames[k], OnItemSelect))
		if(UVSPF.charNames[k] == currentCharName) then
			UVSPF_comboBox:SetSelectedItem(UVSPF.charNames[k])
		end
	end
end

local function UVSPF_UpdateCharList()
	UVSPF.sVar.charInfo = {}
	local id, name
	for i = 1, GetNumCharacters() do
		name, _, _, _, _, _, id, _ = GetCharacterInfo(i)
		UVSPF.sVar.charInfo[i] = {charId = id, charName = zf("<<t:1>>", name),}
	end
end

local function UVSPF_InitSetup()
	local id, name, thisCharId = nil, nil, GCCId()
	local firstRun = ((UVSPF.sVar.firstRun or UVSPF.sVar.numChars == 0 or UVSPF.sVar.charInfo[1] == nil) and true or false)
	--local firstRun = ((UVSPF.sVar.firstRun or UVSPF.sVar.numChars == 0 or UVSPF.sVar.charInfo[1] == nil or UVSPF.sVar.settings[thisCharId] == nil or UVSPF.sVar.ptsData[thisCharId] == nil) and true or false)
	
	--If first run then setup the character table
	if(firstRun) then
		d(GS(UVSPF_MSG_INIT))
		UVSPF.sVar.numChars = GetNumCharacters()
		for i = 1, GetNumCharacters() do
			name, _, _, _, _, _, id, _ = GetCharacterInfo(i)
			UVSPF.sVar.charInfo[i] = {charId = id, charName = zf("<<t:1>>", name),}
			
			--Write the character settings table.
			UVSPF.sVar.settings[id] = {}
			UVSPF.sVar.settings[id] = UVSPF_LTF:CopyTable(UVSPF.settings)
			
			--Write the character points data table.
			UVSPF.sVar.ptsData[id] = {}
			UVSPF.sVar.ptsData[id] = UVSPF_LTF:CopyTable(UVSPF.ptsData)
		end
		
		--Show the welcome message.
		d(GS(UVSPF_MSG_HELP))
		
		UVSPF.sVar.firstRun = false
	end
	
	--Setup the character info table.
	if(not firstRun) then UVSPF_UpdateCharList() end
	
	--Check for added characters.
	for _,v in pairs(UVSPF.sVar.charInfo) do
		if(not UVSPF_LTF:TableContains(UVSPF.sVar.settings, v.charId, true)) then
			UVSPF.sVar.settings[v.charId] = UVSPF_LTF:CopyTable(UVSPF.settings)
		end
		
		if(not UVSPF_LTF:TableContains(UVSPF.sVar.ptsData, v.charId, true)) then
			UVSPF.sVar.ptsData[v.charId] = UVSPF_LTF:CopyTable(UVSPF.ptsData)
		end
	end
	
	--Check for removed characters.
	for k,_ in pairs(UVSPF.sVar.settings) do
		UVSPF.sVar.settings[k] = (UVSPF_LTF:TableContains(UVSPF.sVar.charInfo, k, false) and UVSPF.sVar.settings[k] or nil)
	end
	for k,_ in pairs(UVSPF.sVar.ptsData) do
		UVSPF.sVar.ptsData[k] = (UVSPF_LTF:TableContains(UVSPF.sVar.charInfo, k, false) and UVSPF.sVar.ptsData[k] or nil)
	end
	
	--Create the character select box.
	UVSPF_CreateCharList()
end

local function UVSPF_SkillPointsUpdate(eventCode, pointsBefore, pointsNow, partialPointsBefore, partialPointsNow)
	UVSPF_ResetSelectedCharacter()
	UVSPF_SetupData(GCCId())
end

local function UVSPF_QuestRemoved(eventCode, isCompleted, journalIndex, questName, zoneIndex, poiIndex, questID)
	if(isCompleted) then UVSPF_ResetSelectedCharacter(); UVSPF_SetupData(GCCId()) end
end

local function UVSPF_LevelUp(eventCode, unitTag, level)
	if(unitTag == 'player') then UVSPF_ResetSelectedCharacter(); UVSPF_SetupData(GCCId()) end
end

local function UVSPF_AchComplete(eventCode, name, points, id, link)
	UVSPF_ResetSelectedCharacter()
	UVSPF_SetupData(GCCId())
end

local function UVSPF_AchUpdate(eventCode, id)
	UVSPF_ResetSelectedCharacter()
	UVSPF_SetupData(GCCId())
end

local function UVSPF_PlayerActivated(eventCode)
	UVSPF_ResetSelectedCharacter()
	UVSPF_SetupData(GCCId())
end

local function UVSPF_PlayerDeactivated(eventCode)
	UVSPF_ResetSelectedCharacter()
	UVSPF_SetupData(GCCId())
end

local function UVSPF_Initialized(eventCode, addonName)
	if addonName ~= UVSPF.AddonName then return end
	
	local world = GetWorldName()
	if(world == "NA Megaserver") then
		UVSPF.sVar = ZO_SavedVars:NewAccountWide("UVSPF_Settings", UVSPF.version, nil, UVSPF.defaults)
	else
		UVSPF.sVar = ZO_SavedVars:NewAccountWide("UVSPF_Settings", UVSPF.version, world, UVSPF.defaults)
	end
	
	--Run the startup routine.
	UVSPF_InitSetup()
	
	--Create the keybind(s).
	ZO_CreateStringId("SI_BINDING_NAME_UVSPF_TOGGLE", "Show Skill Point Finder")
	
	--Register the slash commands.
	SLASH_COMMANDS["/UVSPF"] = function(keyWord, argument)
		if(string.lower(keyWord) == "help") then
			UVSPF:HelpSlash()
		elseif(keyWord == "") then
			UVSPF:ToggleWindow()
		elseif(string.lower(keyWord) == "test") then
			UVSPF:TestHarness()
		else
			UVSPF:BadSlash()
		end
	end
	
	local charId = GCCId()
	
	--Load the character settings.
	UVSPF_LoadSettings(charId)
	
	--Create the options menu.
	UVSPF:SetupMenu(charId)
	
	--Call startup routine.
	UVSPF:SetupValues()
	
	--Create the event handlers.
	EM:RegisterForEvent(UVSPF.AddonName, EVENT_SKILL_POINTS_CHANGED, UVSPF_SkillPointsUpdate)
	EM:RegisterForEvent(UVSPF.AddonName, EVENT_QUEST_REMOVED, UVSPF_QuestRemoved)
	EM:RegisterForEvent(UVSPF.AddonName, EVENT_LEVEL_UPDATE, UVSPF_LevelUp)
	EM:RegisterForEvent(UVSPF.AddonName, EVENT_ACHIEVEMENT_AWARDED, UVSPF_AchComplete)
	--EM:RegisterForEvent(UVSPF.AddonName, EVENT_ACHIEVEMENT_UPDATED, UVSPF_AchUpdate)
	EM:RegisterForEvent(UVSPF.AddonName, EVENT_PLAYER_ACTIVATED, UVSPF_PlayerActivated)
	EM:RegisterForEvent(UVSPF.AddonName, EVENT_PLAYER_DEACTIVATED, UVSPF_PlayerDeactivated)
	
	--Kill the initial event handler.
	EM:UnregisterForEvent(UVSPF.AddonName, EVENT_ADD_ON_LOADED)
end

--Register initialization event.
EM:RegisterForEvent(UVSPF.AddonName, EVENT_ADD_ON_LOADED, UVSPF_Initialized)